SystemOrganization addCategory: #'OpenDBX-Core-Structure'!
SystemOrganization addCategory: #'OpenDBX-Core-API'!
SystemOrganization addCategory: #'OpenDBX-Core-Tests'!
SystemOrganization addCategory: #'OpenDBX-Core-Description'!
SystemOrganization addCategory: #'OpenDBX-Core-Benchmark'!

!Time class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:36'!
fromDbxString: aString 
	^ self readDbxFrom: aString readStream! !

!Time class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:11'!
readDbxFrom: aStream
	| hour minute second |

	hour := (aStream upTo: $:) asInteger.
	minute := (aStream upTo: $:) asInteger.
	second := (aStream upToEnd) asInteger.

	^self hour: hour  
		minute: minute 
		second:  second! !

!Time methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:24'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.	
	^ stream contents asDbxString! !

!Time methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:24'!
printDbxOn: aStream
	aStream
		nextPutAll: (self hour asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self minutes asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self seconds asString padded: #left to: 2 with: $0).
! !

!False methodsFor: '*OpenDBX-Core' stamp: 'EL 8/14/2008 09:18'!
asDbxString
	^'false'! !

ExternalStructure subclass: #DBXTimeSpec
	instanceVariableNames: 'seconds nseconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'EL 3/30/2008 15:19'!
fields
	^#(
		(seconds	'long')
		(nseconds	'long'))! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'EL 3/30/2008 15:36'!
seconds: seconds
	^(self new)
		seconds: seconds;
		nseconds: 0;
		yourself.! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'EL 3/30/2008 15:18'!
nseconds
	^ nseconds! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'EL 3/30/2008 15:18'!
nseconds: anObject
	nseconds := anObject! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'EL 3/30/2008 15:18'!
seconds
	^ seconds! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'EL 3/30/2008 15:18'!
seconds: anObject
	seconds := anObject! !

!String class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:11'!
fromDbxString: aString
	^aString! !

!String methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:20'!
asDbxString
	^String new writeStream
		nextPut: $';
		nextPutAll: self;
		nextPut: $';
		contents! !

Notification subclass: #DBXNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

TestCase subclass: #DBXBaseTest
	instanceVariableNames: 'facility connection'
	classVariableNames: 'Facility'
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXBaseTest class methodsFor: 'accessing' stamp: 'MMP 8/5/2008 01:19'!
facility
	^ Facility! !

!DBXBaseTest class methodsFor: 'accessing' stamp: 'MMP 8/5/2008 01:19'!
facility: anObject
	Facility := anObject! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:59'!
doConnect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.	
	conn connect.
	^conn! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
doConnectAndOpen
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.
	conn connect.
	conn open.
	^ conn! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 5/22/2008 00:15'!
doDisconnect: aConnection 
	aConnection disconnect.! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 8/7/2008 23:30'!
dropScript: aConnection 
	"Here we catch the errors because the first time the tests are run, if you didn't create the tables by hand before, you will have an error here (because de table doesn't exist') and it won't continue to the create statements."
	[ aConnection execute: 'DROP TABLE curso' ] 
		on: DBXError
		do: [ :e | . ].
	[ aConnection execute: 'DROP TABLE materia' ] 
		on: DBXError
		do: [ :e |  ].
	[ aConnection execute: 'DROP TABLE alumno' ] 
		on: DBXError
		do: [ :e |  ]! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
facility
	^ facility! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
facility: anObject
	facility := anObject! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
platform
	^ facility platform! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 8/12/2008 23:10'!
runDDLSetUpScript: aConnection 
	"The database structure is the same for all tests and most of them will
	need to have the structure generated. So, this method do exactly that,"
	"Here we catch the errors because the first time the tests are run, if
	you didn't create the tables by hand before, you will have an error
	here (because de table doesn't exist') and it won't continue to the create
	statements."
	self dropScript: aConnection.
	"Now I create all tables, fks, indexes, and so on."
	self facility scriptsDDL
		do: [:script | aConnection execute: script]! !

!DBXBaseTest methodsFor: 'running' stamp: 'HMC 8/4/2008 18:40'!
runDDLTearDownScript: aConnection
self dropScript: aConnection.! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 7/9/2008 02:20'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	self subclassResponsibility! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 8/12/2008 23:13'!
setUp
	"The setUp of this DBXBaseTest lets the database clear to tests. It runs the
	DDL and the common DML script for testing. Then each subclass should
	inserter, delete or whatever it need"
	super setUp.
	"this sould be done from outside"
	facility := self class facility.
	connection := self doConnectAndOpen.
	self runDDLSetUpScript: connection.
	self runDMLSetUpScript: connection! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'EL 7/1/2008 15:19'!
settings
	^ facility connectionSettings! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 7/10/2008 00:43'!
tearDown
	"This method run a DDL script to free results and close the connection used in the setUp and in here"
	super tearDown.
	self runDDLTearDownScript: connection.
	self doDisconnect: connection.
	connection := nil.! !

DBXBaseTest subclass: #DBXCompleteExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXCompleteExamplesTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 21:31'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXCompleteExamplesTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/7/2008 23:33'!
testACompleteExample
	| conn connectionSettings result result2 |
	connectionSettings := self facility connectionSettings deepCopy.
	conn := DBXConnection platform: self platform deepCopy settings: connectionSettings.
	conn connect.
	conn open.
	result := conn execute: 'select * from materia'.
	DBXTranscript show: result.
	conn execute: 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (59, ''TADP'', ''Tecnicas Av'') '.
	conn execute: 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (60, ''APIT'', ''ARQUITECTURA DE PROYECTOS DE IT'') '.
	result := conn execute: 'select * from materia'.
	DBXTranscript show: result.
	result := conn execute: 'delete from materia where nombre = ''TADP'''.
	DBXTranscript show: result.
	result2 := conn execute: 'select * from materia'.
	DBXTranscript show: result2.
	result := conn execute: 'update materia set observaciones = ''something'' where codigo = 60'.
	DBXTranscript show: result.
	result2 := conn execute: 'select * from materia'.
	DBXTranscript show: result2.
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXConnectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:56'!
doConnectAndDisconnect
	| conn |
	conn := self doConnectAndOpen.
	conn disconnect.
	^conn! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 6/17/2008 22:56'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
testCloseIncorrect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.

	"I have not do a open so this should rise an error"
	self 
		should: [ conn close ]
		raise: DBXError.
	"The same if i Try to do a query"
	self 
		should: [ conn execute: 'SELECT * from alumno where id = 1' ]
		raise: DBXError.
	conn := self doConnectAndOpen.
	"The first time should work well"
	conn close.
	"now, as I have already done a close, this shoud rise an error"
	self 
		should: [ conn close ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'EL 7/1/2008 15:24'!
testCloseWithoutOpen
	| conn |
	conn := DBXConnection 
				platform: self platform
				settings: self settings.	
	self should: [ conn close ] raise: DBXError.! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
testConnectAndOpen
	| conn |
	conn := self doConnectAndOpen.
	conn disconnect.
	^ conn! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 19:12'!
testConnectIncorrect
	| conn |
	conn := self doConnectAndOpen.

	"As I have already done a connect: it should raise an error"
	self 
		should: [ conn connect ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:39'!
testConnectOpenCloseOpen
	| conn  |
	conn := self doConnectAndOpen.
	self assert: conn isOpen.
	conn close.
	self assert: conn isOpen not.
	conn open.
	self assert: conn isOpen.
	conn close.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
testDisconnectIncorrect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.

	"I have not do a connect first so this should rise an error"
	self 
		should: [ conn disconnect ]
		raise: DBXError.
	conn := self doConnectAndOpen.
	"The first time should work well"
	conn disconnect.
	"now, as I have already done a disconnect, this shoud rise an error"
	self 
		should: [ conn disconnect ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'EL 7/1/2008 15:26'!
testDisconnectWithoutConnect
	| conn | 
	conn := DBXConnection 
				platform: self platform
				settings: self settings.	
		
	self should: [ conn disconnect ] raise: DBXError.
	! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/8/2008 01:30'!
testGCDisconnection
	"I have to call garbageCollect because maybe there are previous
	connections that are inconsistence or maybe they just have references
	and because of this the GC doesn't clean them. We assume there aren't
	created new connections at the same time of running the test from
	elsewhere"
	| connectionInstancesSizeBeforeTest weakRegistrySizeBeforeTest |
	1
		to: 3
		do: [:i | Smalltalk garbageCollect].
	connectionInstancesSizeBeforeTest := DBXConnection allInstances size.
	weakRegistrySizeBeforeTest := (WeakRegistry default keys
				select: [:each | each class = DBXConnection]) size.
	self doConnectAndOpen.
	1
		to: 3
		do: [:i | Smalltalk garbageCollect].
	self assert: DBXConnection allInstances size = connectionInstancesSizeBeforeTest.
	self assert: (WeakRegistry default keys
			select: [:each | each class = DBXConnection]) size > 0! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/5/2008 01:19'!
testInvalidInputData
	| conn settings |
	
	"If the port is invalid, I should have an error during open"
	settings := (self facility connectionSettings) deepCopy.
	settings port: '1'.
	"If I put localhost instead of 127.0.0.1 it works"
	settings host: '127.0.0.1'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.
	

	"If the ip is invalid, I should have an error during open"
	"IMPORTANT: This test run well but it takes to much time because of the time out. It is commented
	settings := self facility connectionSettings.
	settings host: '192.45.67.8'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError."
	

	"If the database is invalid, I should have an error during open"
	settings := (self facility connectionSettings) deepCopy.
	settings database: 'noExist'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.



	"If the username is invalid, I should have an error during open"
	settings := (self facility connectionSettings) deepCopy.
	settings userName: 'noExist'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.
	

	"If the user password is invalid, I should have an error during open"
	settings := (self facility connectionSettings) deepCopy.
	settings userPassword: 'noExist'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.
	

	"If the authentication method is invalid, I should have an error during open"
	settings := (self facility connectionSettings) deepCopy.
	"Just right now, method must be ZERO"
	settings method: 1.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.

! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 6/17/2008 22:12'!
testManualAndGCDisconnection

	"I have to call garbageCollect because maybe there are previous connections that are inconsistence or maybe they 	just have references and because of this the GC doesn't clean them. We assume there aren't created new connections 	at the same time of running the test from elsewhere "
	
	| connectionInstancesSizeBeforeTest |
	1 to: 3 do: [ :i | Smalltalk garbageCollect ].
	connectionInstancesSizeBeforeTest := DBXConnection allInstances size.
		
	self doConnectAndDisconnect.
	1 to: 3 do: [ :i | Smalltalk garbageCollect ].
	self assert: DBXConnection allInstances size = connectionInstancesSizeBeforeTest.! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:33'!
testManualDisconnection
	| conn conn2 |
	conn := self doConnect.
	conn disconnect.
	conn2 := self doConnectAndOpen.
	conn2 close.
	conn2 disconnect! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 19:12'!
testOpenIncorrect
	| conn |
	conn := self doConnectAndOpen.

	"as I have already open the connection this should rise a DBXError"
	self 
		should: [ conn open ]
		raise: DBXError.
	self 
		should: [ conn open ]
		raise: DBXError.
	self 
		should: [ conn open ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/4/2008 23:57'!
testReOpen
	| conn connectionSettings |
	conn := self doConnectAndOpen.
	connectionSettings := self settings.
	"Actually I should test this with a different database, username and password. "
	conn reOpen: connectionSettings.
	conn close.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:57'!
testShutDownAndStartUp
	| conn  |
	conn := self doConnectAndOpen.
	self assert: conn isOpen.
	conn shutDown.
	self assert: conn isOpen not.
	conn startUp.
	self assert: conn isOpen not.
! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:59'!
testShutDownDisconnection
	| conn  |
	conn := self doConnectAndOpen.
	conn shutDown.
	self assert: conn isOpen not
! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 4/25/2008 02:01'!
testShutDownManualDisconnection
	| conn  |
	conn := self doConnectAndDisconnect.
	self assert: conn isOpen not.
	conn shutDown.
	self assert: conn isOpen not
! !

DBXBaseTest subclass: #DBXDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:17'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/16/2008 20:28'!
testGetColumnDescription
	| conn select result aRow |
	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	self
		should: [result description columnDescriptionAt: 0]
		raise: Error.
	self
		should: [result description columnDescriptionAt: 6]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 1]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 2]
		raise: Error.
	self assert: ((result description columnDescriptionAt: 1) name sameAs: 'codigo').
	aRow := result nextRow.
	self assert: aRow isNil.
	select := 'SELECT codigo FROM materia'.
	result := conn execute: select.
	self
		should: [result description columnDescriptionAt: 2]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 1]
		raise: Error.
	self assert: ((result description columnDescriptionAt: 1) name sameAs: 'codigo').
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:23'!
testGetColumnDescriptionWithName
	| conn select result aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT codigo FROM materia'.
	result := conn execute: select.
	self
		should: [result columnDescriptionWithName: 'noexist']
		raise: DBXError.
	self
		should: [result columnDescriptionWithName: 'nombre']
		raise: DBXError.
	self
		shouldnt: [result columnDescriptionWithName: 'codigo']
		raise: DBXError.
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:16'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 01:57'!
testCompression
	| conn result |
	conn := self doConnect.
	result := conn enableCompression.
	conn open.
	result ifTrue: 
		[ Transcript
			show: 'Compression supported';
			cr.
		self 
			shouldnt: [ conn execute: 'select * from alumno' ]
			raise: Error ].
	result ifFalse: 
		[ Transcript
			show: 'Compression doesnt supported';
			cr.
		self 
			shouldnt: [ conn execute: 'select * from alumno' ]
			raise: Error ].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 01:57'!
testEncryption
	| conn result |
	conn := self doConnect.
	result := conn enableEncryption.
	conn open.
	result ifTrue: 
		[ Transcript
			show: 'Encryption supported';
			cr.
		self 
			shouldnt: [ conn execute: 'select * from alumno' ]
			raise: Error ].
	result ifFalse: 
		[ Transcript
			show: 'Encryption doesnt supported';
			cr.
		self 
			shouldnt: [ conn execute: 'select * from alumno' ]
			raise: Error ].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 01:57'!
testGetOption
	| conn isSupported |
	conn := self doConnect.
	isSupported := conn isOptionSupportedByPlattform: DBXSpecialOptions multipleStatements.
	conn open.
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 02:12'!
testMultipleStatments
	| conn result resultSet |
	conn := self doConnect.
	result := conn enableMultipleStatements.
	conn open.
	result ifTrue: 
		[ Transcript
			show: 'MultipleStatments supported';
			cr.
		conn execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (5, ''Esteban Squeak'', 42) '.
		conn execute: 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (59, ''TADP'', ''Tecnicas Av'') '.
		self 
			shouldnt: 
				[ resultSet := conn execute: 'select id from alumno; select codigo, nombre from materia' ]
			raise: DBXError.
		self assert: resultSet columnCount = 1.
		resultSet nextRow.
		self assert: resultSet columnCount = 1.
		resultSet nextRow.
		self assert: resultSet columnCount = 2.
		self assert: (resultSet nextRow) isNil.
		self assert: resultSet columnCount = 2. ].
	result ifFalse: 
		[ Transcript
			show: 'MultipleStatments doesnt supported';
			cr.
		self 
			should: [ conn execute: 'select * from alumno; select * from materia' ]
			raise: DBXError ].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 01:49'!
testPagedResults
	| conn result resultQuery |
	conn := self doConnect.
	result := conn enablePagedResults.
	conn open.
	result
		ifTrue: [ Transcript show: 'PagedResults supported';
				 cr.
			self
				shouldnt: [resultQuery := conn execute: 'select * from alumno' pageSize: 2.
					DBXTranscript show: resultQuery]
				raise: Error].
	result
		ifFalse: [ Transcript show: 'PagedResults doesnt supported';
				 cr.
			self
				shouldnt: [resultQuery := conn execute: 'select * from alumno'.
					DBXTranscript show: resultQuery]
				raise: Error].
	conn close.
	conn disconnect.
	conn := nil.! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 17:23'!
testScpeialModes
	| conn result update |
	self platform class = DBXMySQLPlatform ifFalse: [ ^ nil ].
	conn := self doConnect.
	result := conn enableSpecialModes: 'ANSI,TRADITIONAL'.
	conn open.
	conn execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (1, ''Mariano Squeak'', 23) '.
	result ifTrue: 
		[ Transcript
			show: 'ScpecialMySQLModes supported';
			cr.
		update := 'update alumno set edad = ''should be numeric'' '.
		self 
			should: [ conn execute: update ]
			raise: DBXError ].
	result ifFalse: 
		[ Transcript
			show: 'ScpecialMySQLModes supported';
			cr.
		update := 'update alumno set edad = ''should be numeric'' '.
		self 
			shouldnt: [ conn execute: update ]
			raise: DBXError ].
	conn close.
	conn disconnect.
	conn := self doConnectAndOpen.
	conn execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (2, ''Mariano Squeak'', 23) '.
	update := 'update alumno set edad = ''should be numeric'' '.
		self 
			shouldnt: [ conn execute: update ]
			raise: DBXError.
	conn := nil. 
! !

DBXBaseTest subclass: #DBXQueryBaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryBaseTest methodsFor: 'running' stamp: 'MMP 8/12/2008 21:15'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (2, ''Hernan Squeak'', 23) '.
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (3, ''German Squeak'', 23) '.
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (4, ''Alejandro Squeak'', 30) '.
	aConnection execute: 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (5, ''Esteban Squeak'', 42) '.
	
	aConnection execute: 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (59, ''TADP'', ''Tecnicas Av'') '.
	aConnection execute: 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (60, ''APIT'', ''ARQUITECTURA DE PROYECTOS DE IT'') '.! !

DBXQueryBaseTest subclass: #DBXQueryDDLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryDDLTest class methodsFor: '*OpenDBX-Core' stamp: 'MMP 8/9/2008 19:27'!
fromDbxString: aString 
	self shouldBeImplemented! !

!DBXQueryDDLTest methodsFor: 'running' stamp: 'MMP 8/9/2008 19:27'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	! !

!DBXQueryDDLTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/9/2008 19:46'!
testExecuteDDLScript
	| conn |
	conn := self doConnectAndOpen.
	conn executeDDLScript: 'DROP TABLE curso;
		DROP TABLE materia;
		DROP TABLE alumno'.
		
	"scriptsDDL := self facility scriptsDDL.
	fullScript := String new writeStream.
	scriptsDDL do: [ :script | fullScript nextPutAll: script ]."
	
! !

DBXQueryBaseTest subclass: #DBXQueryDMLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'HMC 8/7/2008 17:07'!
testDelete
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	self assert: result rowsAffected isNonZero.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'HMC 8/7/2008 17:07'!
testDeleteFollowedByAnotherDelete
	| conn aResult anotherResult aDelete anotherDelete |
	conn := self doConnectAndOpen.
	aDelete  := 'delete from alumno where id = 1'.
	anotherDelete  := 'delete from alumno where id = 2'.
	aResult := conn execute: aDelete.
	self shouldnt: [ anotherResult := conn execute: anotherDelete ] raise: DBXError.
	self assert: aResult rowsAffected isNonZero.
	self assert: anotherResult rowsAffected isNonZero.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'HMC 8/7/2008 17:07'!
testDeleteIsClosedAfterExecute
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	self deny: result isOpen.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'HMC 8/7/2008 17:07'!
testDeleteWithBadData
	| conn delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno where id = should be numeric'.
	self should: [ conn execute: delete  ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'HMC 8/7/2008 17:07'!
testDuplicateDelete
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	self shouldnt: [ conn execute: delete ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'HMC 8/7/2008 17:06'!
testDuplicateInsert
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	result := conn execute: insert.
	self should: [ conn execute: insert ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'HMC 8/7/2008 17:07'!
testDuplicateUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	self shouldnt: [ conn execute: update ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'MMP 8/9/2008 22:50'!
testInsert
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	result := conn execute: insert.
	self assert: result rowsAffected isNonZero.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'HMC 8/7/2008 17:06'!
testInsertFollowedByAnotherInsert
	| conn aResult anotherResult AnInsert anotherInsert |
	conn := self doConnectAndOpen.
	AnInsert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	anotherInsert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (56,''TADP2'',''Nothing'')'.
	aResult := conn execute: AnInsert.
	self shouldnt: [ anotherResult := conn execute: anotherInsert ] raise: DBXError.
	self assert: aResult rowsAffected isNonZero.
	self assert: anotherResult rowsAffected isNonZero.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'HMC 8/7/2008 17:06'!
testInsertIsClosedAfterExecute
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	result := conn execute: insert.
	self deny: result isOpen.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'HMC 8/7/2008 17:07'!
testInsertWithBadData
	| conn insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES ("should be numeric", 1, 1) '.
	self should: [ conn execute: insert  ] raise: DBXError.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'HMC 8/7/2008 17:07'!
testMultipleUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
	result := conn execute: update.
! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'HMC 8/7/2008 17:07'!
testUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	self assert: result rowsAffected isNonZero.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'HMC 8/7/2008 17:07'!
testUpdateFollowedByAnotherUpdate
	| conn aResult anotherResult anUpdate anotherUpdate |
	conn := self doConnectAndOpen.
	anUpdate := 'update alumno set edad = ''25'' '.
	anotherUpdate := 'update alumno set edad = ''23'' '.
	aResult := conn execute: anUpdate.
	self shouldnt: [ anotherResult := conn execute: anotherUpdate ] raise: DBXError.
	self assert: aResult rowsAffected isNonZero.
	self assert: anotherResult rowsAffected isNonZero.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'HMC 8/7/2008 17:08'!
testUpdateIsClosedAfterExecute
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	self deny: result isOpen.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'MMP 8/18/2008 17:30'!
testUpdateWithBadData
	| conn update |
	conn := self doConnect.
	
	self flag: #todo.
	"Only for MySQL, I need to enable ansi and traditional mode in order to get an error in this query. We need the tests refactor for special backends"
	(self platform class = DBXMySQLPlatform) ifTrue: [ conn enableSpecialModes: 'ANSI,TRADITIONAL'. ].
	
	conn open.
	update := 'update alumno set edad = ''should be numeric'' '.
	self
		should: [conn execute: update]
		raise: DBXError! !

DBXQueryBaseTest subclass: #DBXQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 7/11/2008 15:41'!
testCloseBeforeQuery
	| conn select |
	conn := self doConnectAndOpen.
	conn close.
	select := 'SELECT * FROM materia'.
	self
		should: [conn execute: select]
		raise: DBXError.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:29'!
testCloseResultsByClosingConnection
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	conn disconnect.
	self deny: result isOpen.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/13/2008 03:01'!
testCorrectResult
	| conn select result aRow delete update insert drop |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM curso'.
	result := conn execute: select.
	self
		should: [result class = DBXResultSet].
	aRow := result nextRow.
	self assert: aRow isNil.
	delete := 'delete from curso'.
	result := conn execute: delete.
	self
		should: [result class = DBXResult].
	update := 'update materia set nombre = ''XXX'' '.
	result := conn execute: update.
	self
		should: [result class = DBXResult].
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	result := conn execute: insert.
	self
		should: [result class = DBXResult].
	drop := 'drop table curso'.
	result := conn execute: drop.
	self
		should: [result class = DBXResult].
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 7/11/2008 15:43'!
testDisconnectBeforeQuery
	| conn select |
	conn := self doConnectAndOpen.
	conn disconnect.
	select := 'SELECT * FROM materia'.
	self
		should: [conn execute: select]
		raise: DBXError.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:30'!
testEmptyResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia where codigo = 99999'.
	result := conn execute: select.	
	aRow := result nextRow.	
	self assert: aRow isNil.
	result releaseAllQueryResults.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:30'!
testEmptyResultSetRows
	| conn result select rows |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM curso'.
	result := conn execute: select.	
	rows := result nextRow.	
	self assert: rows isNil.
	result releaseAllQueryResults.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:32'!
testHasRowsEmptyResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia where codigo = 99999'.
	result := conn execute: select.	
	aRow := result nextRow.	
	self deny: result hasRows.
	result releaseAllQueryResults.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/9/2008 12:34'!
testIterateResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM alumno'.
	result := conn execute: select.
	[ aRow := result nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: aRow isNil.
	result releaseAllQueryResults.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:33'!
testMultipleSelect
	| conn result select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM materia'.
	result := conn execute: select.
	result releaseAllQueryResults.
	result := conn execute: select.
	result releaseAllQueryResults.
	result := conn execute: select.
	DBXTranscript show: result.
	result releaseAllQueryResults.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result releaseAllQueryResults.
	result := conn execute: select.
	result releaseAllQueryResults.
	result := conn execute: select.
	result releaseAllQueryResults.
	result releaseAllQueryResults.
	result := conn execute: select.
	result := conn execute: select.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	result := conn execute: select.
	conn close.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/7/2008 02:09'!
testNextRowAfterCloseResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn close.
	self should: [ result nextRow ] raise: DBXError.
	conn disconnect.
	
	
	
	! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/5/2008 22:02'!
testNextRowAfterDisconnect
	| conn select result |
	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn disconnect.
	"I have closed de connection, so this should rise an error"
	self
		should: [result nextRow]
		raise: DBXError! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:33'!
testNextRowAfterFinalizeResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	result releaseAllQueryResults.
	
	"I have closed de resultSet, so this should rise an error"	
	self should: [ result nextRow ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/9/2008 22:20'!
testPrintARow
	| conn aResult select aRow stream |
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM alumno'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	stream := String new writeStream.
	aRow values
	do: [:each | stream nextPutAll: each asString]
	separatedBy: [stream nextPutAll: ' | '].
	Transcript show: stream contents;
	cr.	
		
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/9/2008 22:22'!
testQueryAfterQueryWithPartialResutlIteration
	| conn aResult select aRow |
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM alumno'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	aRow := aResult nextRow.
	
	select := 'SELECT * FROM materia'.
	aResult := conn execute: select.
	aRow := aResult nextRow.
	aRow := aResult nextRow.

	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:34'!
testQueryAfterQueryWithPartialResutlIterationWithFinalize
	| conn aResult select aRow |
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM alumno'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	aRow := aResult nextRow.

	aResult releaseAllQueryResults.
	select := 'SELECT * FROM materia'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	aRow := aResult nextRow.
	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MMP 8/8/2008 00:18'!
testQueryAfterQueryWithTotalResutlIteration
	| conn aResult select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM alumno'.
	aResult := conn execute: select.
	aResult
		rowsDo: [:row | Transcript
				show: (row valueNamed: 'EDAD')].
	select := 'SELECT * FROM materia'.
	aResult := conn execute: select.
	aResult
		rowsDo: [:row | Transcript
				show: (row valueNamed: 'codigo')].
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:35'!
testQueryFollowedByAnotherQuery
	| conn aRresult select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM curso'.
	aRresult := conn execute: select.
	self
		shouldnt: [conn execute: select]
		raise: DBXError.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:31'!
testReleaseAllQueryResultsAfterDisconnectResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn disconnect.
	self shouldnt: [ result releaseAllQueryResults ] raise: DBXError.
	
	! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:31'!
testReleaseAllQueryResultsTwiceResultSet
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	result releaseAllQueryResults .
	self shouldnt: [ result releaseAllQueryResults  ] raise: DBXError.	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:36'!
testResultSetNextRow
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	self shouldnt: [ result nextRow ] raise: DBXError.
	result releaseAllQueryResults.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/7/2008 17:36'!
testResultSetWithData
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM alumno where id = 1'.
	result:= conn execute: select.
	aRow := result nextRow.
	self assert: aRow notNil.
	"to execute odbx_result_finish()".
	[ aRow notNil ] whileTrue: [ aRow := result nextRow ].
	result releaseAllQueryResults.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/10/2008 17:07'!
testSelect
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.	
	self shouldnt: [ result nextRow ] raise: DBXError.
	result releaseAllQueryResults.
	conn disconnect.
	
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.	
	DBXTranscript show: result.
	self should: [ result nextRow ] raise: DBXError.
	result releaseAllQueryResults.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/10/2008 17:07'!
testWrongSQL
	| conn select |
	conn := self doConnectAndOpen.
	select:= 'THIS IS NOT VALID SQL'.
	self should: [ conn execute: select. ] raise: DBXError.
	conn disconnect.! !

DBXQueryBaseTest subclass: #DBXRowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXRowTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/16/2008 20:56'!
testRawValueAt
	| conn result select aRow value |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM alumno where id = 1'.
	result := conn execute: select.
	aRow := result nextRow.
	self
		shouldnt: [value := aRow rawValueAt: 1]
		raise: DBXError.
	self assert: value class = ByteString.
	Transcript show: 'raw value: ' , value asString.
	self
		shouldnt: [value := aRow valueAt: 1]
		raise: DBXError.
	self assert: value class = SmallInteger.
	Transcript show: 'raw value: ' , value asString.
	result releaseAllQueryResults.
	conn disconnect! !

!DBXRowTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/12/2008 15:40'!
testRawValueNamed
	| conn result select aRow value |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM alumno where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self assert: [ (value :=aRow rawValueNamed: 'id') = 1 asString].
	result releaseAllQueryResults.
	conn disconnect.
! !

!DBXRowTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/12/2008 16:28'!
testRawValueNamedNotFound
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT nombre_apellido FROM alumno where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self should: [ (aRow rawValueNamed: 'id')] raise: DBXError.
	result releaseAllQueryResults.
	conn disconnect.
! !

!DBXRowTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/12/2008 15:50'!
testRawValues
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT id, nombre_apellido,edad FROM alumno where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self assert: aRow rawValues size = 3.
	result releaseAllQueryResults.
	conn disconnect.
! !

DBXQueryBaseTest subclass: #DBXTransactionalManageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'MMP 8/13/2008 01:42'!
testTransactionCommit
	| conn result delete select |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	result releaseAllQueryResults.
	conn commit.
	select := 'SELECT * FROM alumno'.
	result := conn execute: select.
	self assert: result nextRow isNil.
	result releaseAllQueryResults.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 8/16/2008 21:30'!
testTransactionCommitAfterRollback
	| conn result delete select |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from alumno'.
	conn execute: delete.
	conn rollback.
	conn commit.
	select := 'select * from alumno'.
	result := conn execute: select.
	self assert: result nextRow notNil.
	result releaseAllQueryResults.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 8/16/2008 21:23'!
testTransactionCommitWithoutStartTransaction
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	result releaseAllQueryResults.
	self shouldnt: [conn commit] raise: DBXError.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 8/16/2008 21:29'!
testTransactionRollBackAfterCommit
	| conn result delete select |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	result releaseAllQueryResults.
	conn commit.
	conn rollback.
	select := 'SELECT * FROM alumno'.
	result := conn execute: select.
	self assert: result nextRow isNil.
	result releaseAllQueryResults.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'MMP 8/19/2008 00:48'!
testTransactionRollback
	| conn result delete select |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from alumno'.
	conn execute: delete.
	conn rollback.
	select := 'select * from alumno'.
	result := conn execute: select.
	self assert: result nextRow notNil.
	result releaseAllQueryResults.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 8/16/2008 21:21'!
testTransactionRollbackWithoutAStartTransaction
	| conn result delete select |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno'.
	conn execute: delete.
	conn rollback.
	select := 'select * from alumno'.
	result := conn execute: select.
	self assert: result nextRow isNil.
	result releaseAllQueryResults.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 8/16/2008 21:29'!
testTransactionTwoCommitsInARow
	| conn result delete |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	result releaseAllQueryResults.
	conn commit.
	self shouldnt: [ conn commit ] raise: DBXError.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 8/16/2008 21:29'!
testTransactionTwoRollbacksInARow
	| conn delete |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from alumno'.
	conn execute: delete.
	conn rollback.
	self shouldnt: [ conn rollback ] raise: DBXError.
	conn disconnect! !

DBXBaseTest subclass: #DBXTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTypeTest methodsFor: 'running' stamp: 'EL 8/2/2008 12:27'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/17/2008 09:05'!
testBoolean
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: 'DROP TABLE IF EXISTS test_boolean_columns;'.
		conn execute: '
			CREATE TABLE test_boolean_columns (
				bool_boolean 	BOOLEAN);'.
		conn execute: '		
			INSERT INTO test_boolean_columns
				(bool_boolean)
				VALUES (true);' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_boolean_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'bool_boolean').
		
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/17/2008 09:06'!
testCharacter
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: 'DROP TABLE IF EXISTS test_character_columns;'.
		conn execute: '
			CREATE TABLE test_character_columns (
				char_char		CHAR(10),
				char_varchar	VARCHAR(10));'.
		conn execute: '
			INSERT INTO test_character_columns
				(char_char, char_varchar)
				VALUES (''test'', ''test'');' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_character_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'char_char') = 
		('test' padded: #right to: 10 with: Character space).
	self assert: (row valueNamed: 'char_varchar') = 'test'.
		
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/17/2008 09:15'!
testDatetime
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		[ conn execute: 'DROP TABLE test_datetime_columns;' ]
		on: Error do: [ :e| "table exists" ].
		conn execute: '
			CREATE TABLE test_datetime_columns (
				datetime_date 			DATE,
				datetime_time 			TIME,
				datetime_timestamp 	DATETIME);'.
		conn execute: '
			INSERT INTO test_datetime_columns
				(datetime_date, datetime_time, datetime_timestamp)
				VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_datetime_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'datetime_date') = (Date year: 2008 month: 1 day: 20).
	self assert: (row valueNamed: 'datetime_time') = (Time hour: 10 minute: 20 second: 30).
	self assert: (row valueNamed: 'datetime_timestamp') = 
		(TimeStamp 
			year: 2008 
			month: 1 
			day: 20 
			hour: 10 
			minute: 20 
			second: 30).
		
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/17/2008 09:07'!
testNumeric
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: 'DROP TABLE IF EXISTS test_numeric_columns;'.
		conn execute: '
			CREATE TABLE test_numeric_columns (
				number_decimal 	DECIMAL(5,2),
				number_real 		REAL,
				number_float 		FLOAT,
				number_smallint 	SMALLINT,
				number_integer 		INTEGER);'.
		conn execute: '
			INSERT INTO test_numeric_columns
				(number_decimal, number_real, number_float, number_smallint, number_integer)
				VALUES (42.2, 42.2, 42.2, 42, 42);' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_numeric_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'number_decimal') = 42.2.
	self assert: (row valueNamed: 'number_real') = 42.2.
	self assert: (row valueNamed: 'number_float') = 42.2.
	self assert: (row valueNamed: 'number_smallint') = 42.
	self assert: (row valueNamed: 'number_integer') = 42.
		
	conn close.! !

TestCase subclass: #DBXConnectionSettingsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionSettingsTest methodsFor: 'tests' stamp: 'MMP 7/10/2008 23:30'!
testValidateMethod
	"The method is distinct to zero"
	| settings |
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 5.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: -5.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 'nothing'.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 0.
	self
		shouldnt: [settings validateMethod]
		raise: DBXError! !

!DBXConnectionSettingsTest methodsFor: 'tests' stamp: 'MMP 7/10/2008 23:30'!
testValidatePort
	| settings |
	
	"The port is negative but must be positive"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '-1'. 
	self should: [ settings validatePort ] raise: DBXError.
	
	"The port is zero but must be positive"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '0'. 
	self shouldnt: [settings validatePort] raise: DBXError.
	
	"The not a number but must be positive number"
	settings := DBXConnectionSettings host: '123.4.7.2' port: 'invalidPort'. 
	self should: [ settings validatePort ] raise: DBXError.
	
	"The port is correct"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '88'. 
	self shouldnt: [settings validatePort] raise: DBXError.
		
! !

TestCase subclass: #DBXMainBackendTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/5/2008 01:23'!
facilityToTest
	self subclassResponsibility
	! !

!DBXMainBackendTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/5/2008 01:24'!
testSetToDBXBaseTestAFacility
	DBXBaseTest facility: self facilityToTest.
	! !

DBXMainBackendTest subclass: #DBXMainBackendTestMySQL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestMySQL methodsFor: 'as yet unclassified' stamp: 'MMP 8/5/2008 01:25'!
facilityToTest
	^DBXBackendFacility mySQLFacility! !

DBXMainBackendTest subclass: #DBXMainBackendTestOracle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestOracle class methodsFor: '*OpenDBX-Core' stamp: 'MMP 8/6/2008 01:39'!
fromDbxString: aString 
	self shouldBeImplemented! !

!DBXMainBackendTestOracle methodsFor: 'as yet unclassified' stamp: 'MMP 8/6/2008 01:40'!
facilityToTest
	^DBXBackendFacility oracleFacility! !

DBXMainBackendTest subclass: #DBXMainBackendTestPostgresql
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainBackendTestPostgresql methodsFor: 'as yet unclassified' stamp: 'MMP 8/5/2008 01:25'!
facilityToTest
	^DBXBackendFacility postgresFacility! !

!DateAndTime class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 11:29'!
fromDbxString: aString 
	^self readDbxFrom: aString readStream! !

!DateAndTime class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 11:30'!
readDbxFrom: aStream
	| year month day hour minute second |

	year := (aStream upTo: $-) asInteger.
	month := (aStream upTo: $-) asInteger.
	day := (aStream upTo: Character space) asInteger.
	hour := (aStream upTo: $:) asInteger.
	minute := (aStream upTo: $:) asInteger.
	second := (aStream upToEnd) asInteger.
	
	^ self
		year: year
		month: month
		day: day
		hour: hour
		minute: minute
		second: second.! !

!DateAndTime methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:29'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents asDbxString! !

!DateAndTime methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:30'!
printDbxOn: aStream
	aStream
		nextPutAll: self year asString;
		nextPut: $-;
		nextPutAll: (self monthIndex asString padded: #left to: 2 with: $0);
		nextPut: $-;
		nextPutAll: (self dayOfMonth asString padded: #left to: 2 with: $0);
		nextPut: Character space;	
		nextPutAll: (self hour asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self minutes asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self seconds asString padded: #left to: 2 with: $0).
! !

Object subclass: #DBXAuthenticationMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXAuthenticationMethod class methodsFor: 'methods' stamp: 'MMP 8/16/2008 22:45'!
usernamePassword
	"Returns the method number of openDBX for username and password"
	^0.! !

Object subclass: #DBXBackendFacility
	instanceVariableNames: 'platform connectionSettings scriptsDDL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'MMP 8/19/2008 00:46'!
mySQLFacility
	| facility connectionSettings scriptDDL |
	facility := DBXBackendFacility new.
	connectionSettings := DBXConnectionSettings
				host: 'localhost'
				port: '3306'
				database: 'sodbxtest'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest'.
	facility connectionSettings: connectionSettings.
	facility platform: DBXMySQLPlatform new.
	
	scriptDDL := OrderedCollection new. 
	scriptDDL add: 'CREATE TABLE alumno(
	   id INTEGER,
	   nombre_apellido VARCHAR(30),	   
	   regular BOOLEAN,
	   edad SMALLINT,	   
	   promedio DECIMAL(9,3),
	   sexo CHARACTER(3),
	   descripcion VARCHAR(200),
	   hora_ingreso TIME,
	   fecha_alta DATETIME,
	   fecha_nacimiento DATE,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	) ENGINE = InnoDB ;
'.
"The InnoDB engine is in order to have transaction in this table"
	
	scriptDDL add:  'CREATE TABLE materia(
	codigo INTEGER, 
	nombre CHAR(35),
	observaciones VARCHAR(255),
	CONSTRAINT pk_materias_codigo PRIMARY KEY (codigo)
) ENGINE = InnoDB '.
"The InnoDB engine is in order to have transaction in this table"

	scriptDDL add:  
'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATE,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
) ENGINE = InnoDB '.
"The InnoDB engine is in order to have transaction in this table"

		scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.  
		
			scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES materia(codigo)'.
	
	facility scriptsDDL: scriptDDL. 
	
	^ facility! !

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'MMP 8/16/2008 19:34'!
oracleFacility
	| facility connectionSettings scriptDDL |
	facility := DBXBackendFacility new.
	connectionSettings := DBXConnectionSettings
				host: 'localhost'
				port: '1521'
				database: 'xe'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest'.
	facility connectionSettings: connectionSettings.
	facility platform: DBXOraclePlatform new.
	
	scriptDDL := OrderedCollection new. 
	scriptDDL add: 'CREATE table alumno (
    id               NUMBER NOT NULL,
    nombre_apellido  VARCHAR2(4000),
    regular          NUMBER(1),
    edad             NUMBER,
    promedio         NUMBER(9,3),
    sexo             VARCHAR2(4000),
    descripcion      VARCHAR2(4000),
    hora_ingreso     TIMESTAMP,
    fecha_alta       DATE,
    fecha_nacimiento DATE,
    constraint  alumno_PK primary key (id)
)
'.
	
	scriptDDL add:  'CREATE table materia (
    codigo        NUMBER NOT NULL,
    nombre        VARCHAR2(4000),
    observaciones VARCHAR2(4000),
    constraint  materia_pk primary key (codigo)
)'.
	
	scriptDDL add:  
'CREATE table curso (
    id_curso       NUMBER NOT NULL,
    id_alumno      NUMBER,
    codigo_materia NUMBER,
    fecha_inicio   DATE,
    constraint  curso2_pk primary key (id_curso)
)'.

"
		scriptDDL add: '
alter table curso add constraint
co_ao_fk foreign key (id_alumno) references alumno (id)
'.  
		
			scriptDDL add: 'alter table curso add constraint
co_ma_fk foreign key (codigo_materia) references materia (codigo)
'.
	"
	facility scriptsDDL: scriptDDL. 
	
	^ facility! !

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'MMP 8/11/2008 22:13'!
postgresFacility
	| facility connectionSettings scriptDDL |
	facility := DBXBackendFacility new.
	connectionSettings := DBXConnectionSettings
				host: 'localhost'
				port: '5432'
				database: 'sodbxtest'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest'.
	facility connectionSettings: connectionSettings.
	facility platform: DBXPostgresPlatform new.
	
	scriptDDL := OrderedCollection new. 
	scriptDDL add: 'CREATE TABLE alumno(
	   id INTEGER,
	   nombre_apellido VARCHAR,	   
	   regular BOOLEAN,
	   edad SMALLINT,	   
	   promedio DECIMAL(9,3),
	   sexo CHARACTER(3),
	   descripcion VARCHAR,
	   hora_ingreso TIME,
	   fecha_alta TIMESTAMP,
	   fecha_nacimiento DATE,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	)'.
	
	scriptDDL add:  'CREATE TABLE materia(
	codigo INTEGER, 
	nombre CHAR(35),
	observaciones VARCHAR(255),
	CONSTRAINT pk_materias_codigo PRIMARY KEY (codigo)
)'.
	
	scriptDDL add:  
'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATE,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
)'.


		scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.  
		
			scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES materia(codigo)'.
	
	facility scriptsDDL: scriptDDL. 
	
	^ facility! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
connectionSettings
	^ connectionSettings! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
connectionSettings: anObject
	connectionSettings := anObject! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
platform
	^ platform! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
platform: anObject
	platform := anObject! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 8/7/2008 02:52'!
scriptsDDL
	^ scriptsDDL! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 8/7/2008 02:52'!
scriptsDDL: anObject
	scriptsDDL := anObject! !

Object subclass: #DBXBenchmark
	instanceVariableNames: 'times facility'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXBenchmark class methodsFor: 'defaults' stamp: 'EL 7/2/2008 11:57'!
defaultFacility
	^DBXBackendFacility postgresFacility ! !

!DBXBenchmark class methodsFor: 'defaults' stamp: 'EL 7/1/2008 21:31'!
defaultRuns
	^10! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 8/19/2008 10:37'!
collect: aBlock
	self runs timesRepeat: [
		self setUpOnce. 
		times add: (MessageTally time: aBlock).
		self tearDownOnce. ]! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:18'!
collectedTimeAverage
	^((times inject: 0 into: [ :v :each | v + each ]) / self class defaultRuns) asFloat! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/2/2008 11:57'!
facility
	^facility ifNil: [ facility := self class defaultFacility ]! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/2/2008 11:57'!
facility: aFacility
	facility := aFacility! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:32'!
findBenchmarks
	^self class allSelectors asSortedCollection asOrderedCollection select: [:each | 
		('benchmark*' match: each) and: [each numArgs isZero]]! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/1/2008 21:58'!
log: aString
	Transcript show: aString; cr.! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:18'!
prepareCollector
	times := OrderedCollection new.
	! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/2/2008 11:55'!
run: aSelector
	self prepareCollector.
	self setUp.
	self collect: [ self perform: aSelector ].
	self tearDown.
	self log: aSelector, ': ', self collectedTimeAverage asString, ' AVG'.
	! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/1/2008 21:59'!
runAll
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self run: each ] ! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/1/2008 21:31'!
runs
	^self class defaultRuns ! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/2/2008 11:55'!
setUp! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/19/2008 10:37'!
setUpOnce! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/2/2008 11:55'!
tearDown! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/19/2008 10:37'!
tearDownOnce! !

DBXBenchmark subclass: #DBXTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXTinyBenchmarks class methodsFor: 'defaults' stamp: 'EL 8/19/2008 09:00'!
defaultBenchmarkRows
	^10! !

!DBXTinyBenchmarks class methodsFor: 'defaults' stamp: 'EL 8/19/2008 10:00'!
defaultInserts
	^800! !

!DBXTinyBenchmarks class methodsFor: 'defaults' stamp: 'EL 7/1/2008 21:31'!
defaultRuns
	^100! !

!DBXTinyBenchmarks class methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 08:57'!
prepareBenchmark
	self prepareBenchmarkRows: self defaultBenchmarkRows.! !

!DBXTinyBenchmarks class methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 08:57'!
prepareBenchmarkRows: aNumber
	self new prepareDataRows: aNumber! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/19/2008 09:56'!
benchmarkInsert
	self class defaultInserts timesRepeat: [ 
		connection execute: 
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, bool, str1, str2, date1, date2, date3)
			VALUES 
				(1.0, 1.0, 1.0, 1, true, ''test'', ''test'', ''2008-01-01'', ''10:00:00'', ''2008-01-01 10:00:00'')' ]
! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/19/2008 10:24'!
benchmarkInsertConverted
	| date time dateAndTime |
	
	date := Date current. 
	time := Time current.
	dateAndTime := DateAndTime current. 
	1 to: self class defaultInserts do: [ :i |  
		connection execute: (
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, bool, str1, str2, date1, date2, date3)
			VALUES ({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10})' 
					format: (OrderedCollection new
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asDbxString;
						add: i odd asDbxString;
						add: i asString asDbxString;
						add: i asString asDbxString;
						add: date asDbxString;
						add: time asDbxString;
						add: dateAndTime asDbxString;
						yourself)) ]
! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/14/2008 09:15'!
benchmarkSelect
	(connection execute: 'SELECT * FROM tiny_benchmark')
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 8/14/2008 09:25'!
initialize
	super initialize.
	self initializeConnection.! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/26/2008 13:49'!
initializeConnection
	connection := DBXConnection
		platform: self facility platform
		settings: self facility connectionSettings.
	connection connect.
	connection open.
! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 8/19/2008 10:45'!
prepareDataRows: aNumber
	connection execute: 'DROP TABLE IF EXISTS tiny_benchmark'.
	connection execute: '
		CREATE TABLE tiny_benchmark (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			bool 	BOOLEAN,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIME,
			date3 	TIMESTAMP,
			PRIMARY KEY (id))'.
			
		1 to: aNumber do: [ :i | 
			connection execute: (
				'INSERT INTO tiny_benchmark  
					(id, num1, num2, num3, num4, bool, str1, str2, date1, date2, date3)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10}, {11})' 
					format: (OrderedCollection new
						add: i asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asDbxString;
						add: i odd asDbxString;
						add: i asString asDbxString;
						add: i asString asDbxString;
						add: Date current asDbxString;
						add: Time current asDbxString;
						add: DateAndTime current asDbxString;
						yourself)) ].! !

!DBXTinyBenchmarks methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 10:46'!
prepareInsert
	connection execute: 'DROP TABLE IF EXISTS tiny_benchmark_insert'.
	connection execute: '
		CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			bool 	BOOLEAN,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIME,
			date3 	TIMESTAMP)'.! !

!DBXTinyBenchmarks methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 10:46'!
setUp
	self prepareInsert.! !

DBXBenchmark subclass: #PGTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!PGTinyBenchmarks class methodsFor: 'defaults' stamp: 'EL 8/19/2008 10:54'!
defaultInserts
	^800! !

!PGTinyBenchmarks class methodsFor: 'defaults' stamp: 'EL 7/1/2008 21:33'!
defaultRuns
	^100! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/19/2008 10:53'!
benchmarkInsert
	self class defaultInserts timesRepeat: [ 
		connection execute: 
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, bool, str1, str2, date1, date2, date3)
			VALUES 
				(1.0, 1.0, 1.0, 1, true, ''test'', ''test'', ''2008-01-01'', ''10:00:00'', ''2008-01-01 10:00:00'')' ]
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/19/2008 10:54'!
benchmarkInsertConverted
	| date time dateAndTime |
	
	date := Date current. 
	time := Time current.
	dateAndTime := DateAndTime current. 
	1 to: self class defaultInserts do: [ :i |  
		connection execute: (
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, bool, str1, str2, date1, date2, date3)
			VALUES ({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10})' 
					format: (OrderedCollection new
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asDbxString;
						add: i odd asDbxString;
						add: i asString asDbxString;
						add: i asString asDbxString;
						add: date asDbxString;
						add: time asDbxString;
						add: dateAndTime asDbxString;
						yourself)) ]
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/14/2008 09:19'!
benchmarkSelect
	(connection  execute: 'SELECT * FROM tiny_benchmark') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/1/2008 21:33'!
initialize
	super initialize.
	self initializeConnection.! !

!PGTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/26/2008 13:07'!
initializeConnection
	connection := PGConnection new
		connectionArgs: (PGConnectionArgs new
			hostname: 'localhost';
			portno: 5432;
			databaseName: 'sodbxtest';
			userName: 'sodbxtest';
			password: 'sodbxtest');
		yourself.
	connection startup.
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/19/2008 10:53'!
prepareInsert
	connection execute: 'DROP TABLE IF EXISTS tiny_benchmark_insert'.
	connection execute: '
		CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			bool 	BOOLEAN,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIME,
			date3 	TIMESTAMP)'.! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/19/2008 10:53'!
setUp
	self prepareInsert! !

Object subclass: #DBXColumnDescription
	instanceVariableNames: 'type dbxType name size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'HMC 8/16/2008 21:16'!
name: aString dbxType: aNumber type: aType
"this instantiates a new DBXColumnDescription with a type size of zero"
	^self name: aString dbxType: aNumber type: aType size: 0! !

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'HMC 8/16/2008 21:18'!
name: aNameString dbxType: aNumber type: aTypeSymbol size: aTypeSizeNumber
"this instantiates a new DBXColumnDescription, whitch will hold the name, data type and size of the data type the rows from the database have"
	^(super new)
		name: aNameString;
		type: aTypeSymbol;
		size: aTypeSizeNumber;
		yourself.! !

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'EL 3/31/2008 11:58'!
new
	self error: 'Use caption:type:'! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:56'!
dbxType
"this is the data type of this column, according to its data type from the database"
	^ dbxType! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 8/3/2008 08:45'!
dbxType: anObject
	dbxType := anObject! !

!DBXColumnDescription methodsFor: 'testing' stamp: 'HMC 8/16/2008 20:54'!
isLarge
"see DBXPlatform isLarge"
	^DBXPlatform isLarge: self dbxType! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:57'!
name
"this is the name of this column, according to its database name, "
	^name! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:49'!
name: aString
	name := aString! !

!DBXColumnDescription methodsFor: 'printing' stamp: 'EL 6/27/2008 20:45'!
printOn: aStream
	aStream nextPut: $(.
	self name printOn: aStream.
	aStream nextPut: $:.
	self type printOn: aStream.
	aStream nextPut: $).! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:15'!
size
"size of the data type"
	^size! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:50'!
size: aNumber
	size := aNumber! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:59'!
type
"type of the data that a column description holds"
	^ type! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 3/31/2008 11:24'!
type: anObject
	type := anObject! !

Object subclass: #DBXConnection
	instanceVariableNames: 'platform settings handle open connected resultSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXConnection class methodsFor: 'initialization' stamp: 'MMP 4/15/2008 00:37'!
initialize
	"DBConnection initialize"

	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!DBXConnection class methodsFor: 'logging' stamp: 'EL 5/12/2008 18:50'!
log: message
	Transcript show: message; cr.! !

!DBXConnection class methodsFor: 'instance creation' stamp: 'EL 7/1/2008 16:51'!
platform: aPlatform settings: aConnectionSettings
	^self new
		platform: aPlatform;
		settings: aConnectionSettings;
		yourself! !

!DBXConnection class methodsFor: 'system startup' stamp: 'MMP 7/9/2008 19:49'!
shutDown
	self
		allInstancesDo: [:each | each shutDown]! !

!DBXConnection class methodsFor: 'system startup' stamp: 'EL 7/1/2008 20:52'!
startUp
	"Right now i do nothing in the startup. Perhaps in a future I should open the connections that were closed when the image was down"
"	self allInstancesDo: [ :each| each startUp ]."! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 5/12/2008 18:45'!
= aDBXConnection
	^ self handle = aDBXConnection handle.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 8/12/2008 01:11'!
close
	"It closes the connection releasing all the resultSets. It will probably free tcp/ip database connection. You must re open it in order to execute more queries"
	self isOpen
		ifFalse: [DBXError signal: 'Error: The connection is not open. Try opening it first.'].
	self releaseResultSets.
	self platform closeConnection: self.
	self internalBeClosed! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'HMC 8/16/2008 20:17'!
commit
"executes a commit statement"
	| aResultSet |
	self isOpen ifFalse: 
		[ DBXError signal: 'Error: You cannot commit if the connection is not open' ].
	self resultSet ifNotNil: [ self resultSet releaseAllQueryResults ]. "sacar esto a un metodo"
	aResultSet := self platform commit: self.
	resultSet := aResultSet.
	^ resultSet! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 8/12/2008 01:15'!
connect
	"This is the first method that must be called to a connection. It connects to database host and creates all the data structure for a connection. After it, you can call open. You cannot connect an already connected connection"
	self isConnected
		ifTrue: [DBXError signal: 'You are already connected. Try disconnecting before'].
	self validateSettingsForConnect.
	"WARNING This is the only place where we have direct access to
	handles... "
	handle := self platform createConnection: self.
	WeakRegistry default add: self.
	self internalBeConnected! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 8/12/2008 01:38'!
connectAndOpen
"Take into consideration that using this method you cannot specify special options because 
many of them should be called between connect and open operations
In case you don't want to use any SqueakDBX special options, you can use this message. However, we recommend to use connect and open separately"	
	self connect.
	self open.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 8/12/2008 01:10'!
disconnect
	" Disconnect from database releasing all resultSets. No operation will be permitted after it. It must be call when you finish using the connection. If the connection wasn't close, it will do it. In order to do a disconnection, the connection must be connected'"
	self isConnected
		ifFalse: [DBXError signal: 'Error: The connection is not connected. Try connecting first.'].
	self isOpen
		ifTrue: [self close].
	self releaseConnection.
	self internalBeDisconnected.
	handle := nil! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:29'!
enableCompression
	"It tries to enable Compression option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions compression.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:29'!
enableEncryption
"It tries to enable Encryption option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions encryption.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:29'!
enableMultipleStatements
"It tries to enable Multiple Statements option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions multipleStatements! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:30'!
enablePagedResults
"It tries to enable paged results. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions pagedResults.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/18/2008 16:21'!
enableSpecialModes: modes 
	"It tries to enable specific modes. For example MySQL special modes (http://dev.mysql.com/doc/refman/5.0/en/server-sql-mode.html). If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	(self isOptionSupportedByPlattform: DBXSpecialOptions specialModes) ifTrue: 
		[ self platform 
			setOption: DBXSpecialOptions specialModes
			value: modes
			on: self.
		^ true ].
	^ false! !

!DBXConnection methodsFor: 'private' stamp: 'MMP 8/12/2008 01:34'!
enableSpecialOption: specialOption 
	"It returns if the specialOption could be enable or not.
	Before enabling a specific option, I must be sure the current backend
	support it"
	(self isOptionSupportedByPlattform: specialOption)
		ifTrue: [self platform
				setOption: specialOption
				value: true
				on: self.
				^true.].
		^false.
! !

!DBXConnection methodsFor: 'query' stamp: 'MMP 8/13/2008 01:20'!
execute: aString 
	"This message is used for ALL type of query: SQL, DML and DDL.
	Depending on the type of query it will return DBXResult or
	DBXResultSet. 
	The queries sent to the server must be understood by the DBMS because
	there is no translation done between the different dialects of SQL for
	example. 
	
	To execute a query you must be connected and open.
	
	Some queries return more than one resultSet. This situation will be
	transparent for SqueakDBX user. DBXResultSet #nextRow will
	automatically obtain next resultSet when needed
	
	You DON'T need to call nextRow till nil its returned, the framework will
	do it for you in your next query.
	"
	| aResultSet |
	self isOpen
		ifFalse: [DBXError signal: 'Error: You cannot execute a query if the connection is not open'].
	self resultSet
		ifNotNil: [self resultSet releaseAllQueryResults].
	aResultSet := self platform executeStatement: aString on: self.

	resultSet := aResultSet.
	^ aResultSet! !

!DBXConnection methodsFor: 'query' stamp: 'HMC 8/16/2008 20:15'!
execute: aString pageSize: aNumber 
	"Same as execute, but it ads a page size. Dependent on the native
	database library, it may be possible to retrieve all rows at once (if the
	page size parameter is zero), one by one or more than one row at once.
	All positive values including zero are allowed as values for the page size If
	paging (more than one row at once) is not supported by the backend, it
	will use one by one or all at once if this is the only option provided.
	"
	| aResultSet |
	self isOpen
		ifFalse: [DBXError signal: 'Error: You cannot execute a query if the connection is not open'].
	self resultSet
		ifNotNil: [self resultSet releaseAllQueryResults].
	aResultSet := self platform
				executeStatement: aString
				on: self
				pageSize: aNumber.
	resultSet := aResultSet.
	^ aResultSet! !

!DBXConnection methodsFor: 'query' stamp: 'MMP 8/12/2008 01:54'!
executeDDLScript: aDDLScript 
"Its very common you need to execute a complete DDL script: create, drop or alter tables. In these cases, you don't have any interesting results from each query. In such a case, you should use this method. Remember SqueakDBX doesn't do any translation so your statement delimiter must be understood by the backend. In order to know which delimiter we use, you can see the message queryDelimiter of the current platform backend, for example DBXPostgresPlatform.
This message doesn't use the multistatements option of openDBX, it is all done by SqueakDBX so you don't have to care about it''"

	| ddlStatements |
	ddlStatements := aDDLScript findTokens: self platform queryDelimiter.
	ddlStatements
		do: [:ddlStatement | self execute: ddlStatement]! !

!DBXConnection methodsFor: 'finalization' stamp: 'MMP 8/12/2008 01:18'!
finalize
	" If it is connected, it will disconnect it"
	self isConnected ifTrue: [ self disconnect ]! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 3/30/2008 14:41'!
handle
	^handle! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 5/1/2008 18:37'!
hash
	^ self handle hash! !

!DBXConnection methodsFor: 'initialization' stamp: 'MMP 8/12/2008 01:26'!
initialize
	super initialize.
	"These ValueHolder are very important and you cannot change them. If you instantiate a DBXConnection and never do the disconnect, SqueakDBX will do it whe the object is garbage collected. How SqueakDBX do that? DBXConnection is registered in the default WeakRegistry. So, when you call connect we add the object to that registry. In that moment a clone is generated from the original object. Suppose you then do the disconnect to the original object. If we don't use ValueHolder, the clone will have other objects for open and connected and because of this, the disconnect will be called twice, generating an openDBX error.' "
	open := ValueHolder new contents: false.
	connected := ValueHolder new contents: false.
	resultSet := nil! !

!DBXConnection methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:59'!
initializePlatform: aPlatform settings: aConnectionSettings handle: aNumber
	platform := aPlatform.
	settings := aConnectionSettings.
	handle := aNumber.
	self internalBeConnected.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeClosed
	open contents: false! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeConnected
	connected contents: true.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeDisconnected
	connected contents: false.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeOpen
	open contents: true.! !

!DBXConnection methodsFor: 'testing' stamp: 'MMP 4/25/2008 00:44'!
isConnected
	^connected contents.! !

!DBXConnection methodsFor: 'testing' stamp: 'MMP 4/25/2008 00:44'!
isOpen
	^open contents.! !

!DBXConnection methodsFor: 'private' stamp: 'MMP 8/12/2008 01:32'!
isOptionSupportedByPlattform: specialOption 
"It returns if the specialOption is supported by the backend"
	^self platform
		getOption: specialOption
		on: self.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 8/12/2008 01:13'!
open
	"Opens the connection. You must first do a connect and you cannot call this method if the connection is already open.. This method will probably opens the tcp/ip database connection. After calling this method, you should be able to send queries"
	self isConnected ifFalse: [
		DBXError signal: 'Error: You are not connected. Try connecting first'  ].
	self isOpen ifTrue: [ 
		DBXError signal: 'Error: The connection is already open' ].
	self validateSettingsForOpen.
	self platform openConnection: self.
	self internalBeOpen! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/10/2008 01:06'!
platform
	^platform! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 7/1/2008 16:54'!
platform: aPlatform
	platform := aPlatform! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 8/12/2008 01:41'!
reOpen: aConnectionSettings
	"It simply do a close and an open with the new connectionSettings. 
	Suppouse you have a DBXConnection connected and open. Sometimes it may be necessary to connect to a different database (schema) or re-authenticate using different credentials. In such a case you can use this message"
	self isConnected ifFalse: [
		DBXError signal: 'Error: You are not connected. Try connecting first'  ].
	self isOpen ifFalse: [ 
		DBXError signal: 'Error: The connection must be open in order to reOpen it' ].
	self close.
	self settings: aConnectionSettings.
	self open.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/29/2008 10:52'!
releaseConnection
	self platform releaseConnection: self! !

!DBXConnection methodsFor: 'private' stamp: 'MMP 8/11/2008 22:06'!
releaseResultSets
	resultSet finalize! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 8/11/2008 22:09'!
resultSet
	^resultSet! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 8/11/2008 22:08'!
resultSet: anObject 
	resultSet := anObject! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'HMC 8/16/2008 20:17'!
rollback
"executes a rollback statement"
	| aResultSet |
	self isOpen ifFalse: 
		[ DBXError signal: 'Error: You cannot rollback if the connection is not open' ].
	self resultSet ifNotNil: [ self resultSet releaseAllQueryResults ].
	aResultSet := self platform rollback: self.
	resultSet := aResultSet.
	^ resultSet! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:42'!
settings
	^ settings! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 7/1/2008 16:54'!
settings: aConnectionSettings
	settings := aConnectionSettings! !

!DBXConnection methodsFor: 'running' stamp: 'MMP 8/12/2008 01:56'!
shutDown
	"This message is called when the object is garbage collected. In case the connection was connected, but not disconnected, it will be disconnected"
	 self isConnected ifTrue: [
		self disconnect ]
! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'HMC 8/16/2008 20:17'!
startTransaction
"executes a start transaction statement"
	| aResultSet |
	self isOpen ifFalse: 
		[ DBXError signal: 'Error: You cannot start a transaction if the connection is not open' ].
	self resultSet ifNotNil: [ self resultSet releaseAllQueryResults ].
	aResultSet := self platform startTransaction: self.
	resultSet := aResultSet.
	^ resultSet! !

!DBXConnection methodsFor: 'running' stamp: 'MMP 8/12/2008 01:54'!
startUp
	"till now, nothing is done on the startup"! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 7/10/2008 23:25'!
validateSettingsForConnect
	self settings validatePort.! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 7/10/2008 23:25'!
validateSettingsForOpen
	self settings method.! !

Object subclass: #DBXConnectionSettings
	instanceVariableNames: 'host port database userName userPassword method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:13'!
host: aHost port: aPort
	^ self basicNew
		initializeHost: aHost 
			port: aPort;
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:31'!
host: aHost port: aPort database: aDatabase userName: aUsername userPassword: aPassword
	^ self basicNew
		initializeHost: aHost 
			port: aPort 
			database: aDatabase 
			userName: aUsername  
			userPassword: aPassword;
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:32'!
host: aDatabase userName: aUsername userPassword: aPassword
	^ self basicNew
		initializeHost: aDatabase 
			userName: aUsername  
			userPassword: aPassword
		yourself! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
database
	^ database! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
database: anObject
	database := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 6/10/2008 00:50'!
host
	^ host! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
host: anObject
	host := anObject! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:11'!
initializeHost: aHost port: aPort
	self initialize.
	host := aHost.
	port := aPort! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:12'!
initializeHost: aHost port: aPort database: aDatabaseName userName: aUserName userPassword: aPassword
	self initialize.
	host := aHost.
	port := aPort.
	database := aDatabaseName.
	userName := aUserName.
	userPassword := aPassword.! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:13'!
initializeHost: aDatabaseName userName: aUserName userPassword: aPassword
	self initialize.
	database  := aDatabaseName.
	userName := aUserName.
	userPassword := aPassword.! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/11/2008 00:24'!
method
	^ method ifNil: [ method := DBXAuthenticationMethod usernamePassword ]! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
method: anObject
	^ method := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 6/10/2008 00:50'!
port
	^ port! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
port: anObject
	port := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
userName
	^ userName! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
userName: anObject
	userName := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
userPassword
	^ userPassword! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
userPassword: anObject
	userPassword := anObject! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'MMP 7/11/2008 00:24'!
validateMethod
	self method notNil ifTrue: 
		[ self method = DBXAuthenticationMethod usernamePassword ifFalse: [ DBXError signal: 'The only supported method is zero' ] ]! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 8/18/2008 12:44'!
validatePort
	self flag: #todo. "This validation doesn't work with Pharo... disabling temporaly"
	"self port notNil
		ifTrue: [(self port isPositiveInteger)
			ifFalse: [DBXError signal: 'The port must be a positive number']]"! !

Object subclass: #DBXPlatform
	instanceVariableNames: ''
	classVariableNames: 'DataTypesMap'
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the platform abstraction layer. 
I comunicate directly with OpenDBX, and provide a fplatform specific abstraction layer. !

DBXPlatform subclass: #DBXMySQLPlatform
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXMySQLPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the MySQL specific platform definition. 

Instance Variables
	handle:		<Object>

handle
	- xxxxx
!

!DBXMySQLPlatform methodsFor: 'as yet unclassified' stamp: 'EL 6/27/2008 20:30'!
backend
	^'mysql'! !

!DBXMySQLPlatform methodsFor: 'resultSet' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

DBXPlatform subclass: #DBXOraclePlatform
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXOraclePlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the Oracle specific platform definition. 

Instance Variables
	handle:		<Object>

handle
	- xxxxx
!

!DBXOraclePlatform class methodsFor: 'transactional manage' stamp: 'HMC 8/12/2008 13:29'!
startTransaction
^'hello'! !

!DBXOraclePlatform methodsFor: 'accessing' stamp: 'MMP 8/6/2008 01:38'!
backend
	^'oracle'! !

!DBXOraclePlatform methodsFor: 'accessing' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

!DBXOraclePlatform methodsFor: 'accessing' stamp: 'MMP 8/13/2008 03:25'!
startTransaction
	"This is a general approach for starting a transaction. If other approach is wanted, like SET TRANSACTION READ ONLY, you must do it manually like any other query."
	^'SET TRANSACTION READ WRITE'! !

!DBXPlatform class methodsFor: 'defaults' stamp: 'EL 8/14/2008 09:31'!
createDataTypesMap
	^Dictionary new
		at: 16r00 put: Boolean; "BOOLEAN"
		at: 16r01 put: Number; "SMALLINT"
		at: 16r02 put: Number; "INTEGER"
		at: 16r03 put: Number; "BIGINT"
		at: 16r07 put: Number; "DECIMAL"
		at: 16r08 put: Number; "REAL"
		at: 16r09 put: Number; "DOUBLE"
		at: 16r0F put: Number; "FLOAT"
		at: 16r10 put: String; "CHAR"
		at: 16r11 put: String; "NCHAR"
		at: 16r12 put: String; "VARCHAR"
		at: 16r13 put: String; "NVARCHAR"
		at: 16r20 put: (DBXTypeNotSupported type: #CLOB);
		at: 16r21 put: (DBXTypeNotSupported type: #NCLOB);
		at: 16r22 put: (DBXTypeNotSupported type: #XML);
		at: 16r2F put: (DBXTypeNotSupported type: #BLOB);
		at: 16r30 put: Time; "TIME"
		at: 16r31 put: Time; "TIMETZ"
		at: 16r32 put: TimeStamp; "TIMESTAMP"
		at: 16r33 put: TimeStamp; "TIMESTAMPTZ"
		at: 16r34 put: Date; "DATE"
		at: 16r35 put: (DBXTypeNotSupported type: #INTERVAL);
		at: 16r40 put: (DBXTypeNotSupported type: #ARRAY);
		at: 16r41 put: (DBXTypeNotSupported type: #MULTISET);
		at: 16r50 put: (DBXTypeNotSupported type: #DATALINK);
		at: 16rFF put: (DBXTypeNotSupported type: #UNKNOWN);
		yourself
! !

!DBXPlatform class methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
dataTypeAt: aNumber
	^self dataTypesMap at: aNumber ifAbsent: [ DBXTypeNotSupported code: aNumber ]! !

!DBXPlatform class methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:58'!
dataTypesMap
	^DataTypesMap ifNil: [ DataTypesMap := self createDataTypesMap ]! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 8/3/2008 08:53'!
isLarge: aNumber
	"Answer true if aNumber represents a large data object (BLOB, CLOB, NCLOB)"
	^#(16r20 16r21 16r2F) includes: aNumber! !

!DBXPlatform class methodsFor: 'as yet unclassified' stamp: 'MMP 8/16/2008 23:10'!
log: message
	Transcript show: message; cr.! !

!DBXPlatform class methodsFor: 'as yet unclassified' stamp: 'EL 8/5/2008 08:44'!
reset
	DataTypesMap := nil.! !

!DBXPlatform methodsFor: 'accessing' stamp: 'HMC 8/18/2008 12:01'!
backend
	"Returns the name of the backend that OpenDBX understands for each RDBMS"
	^self subclassResponsibility! !

!DBXPlatform methodsFor: 'connection' stamp: 'HMC 8/18/2008 12:02'!
closeConnection: aConnection
	"Closes the connection and throws a DBXError if an error occurs"
	| err |
	err := OpenDBX current apiUnbind: aConnection handle.
	self verifyError: err on: aConnection.
! !

!DBXPlatform methodsFor: 'constants' stamp: 'MMP 8/13/2008 03:25'!
commit
	^'COMMIT'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'HMC 8/18/2008 12:33'!
commit: aConnection
"executes a commit statement on a connection"
^self executeStatement: self commit on: aConnection.! !

!DBXPlatform methodsFor: 'connection' stamp: 'HMC 8/18/2008 12:12'!
createConnection: aConnection 
	"It initializes and creates a handle for all further operations, and it is
	used within the OpenDBX library to identify the connection and to
	maintain connection information. Depending on the backend it can open
	a connection to the database server but often this is done not until
	performing authentication through 'openConnection:'
	throws an error if needed"
	| err handleArray handle |
	handleArray := WordArray with: 0.
	err := OpenDBX current
				apiInitialize: handleArray
				backend: self backend
				host: aConnection settings host
				port: aConnection settings port.
	handle := handleArray at: 1.
	self verifyError: err handle: handle.
	^ handle! !

!DBXPlatform methodsFor: 'private' stamp: 'EL 8/6/2008 08:59'!
descriptionForColumn: anIndex handle: aHandle on: aConnection
	"anIndex is Zero based"
	| columnName dbxType |
	columnName := OpenDBX current apiQueryColumnName: aHandle index: anIndex.
	dbxType := OpenDBX current apiQueryColumnType: aHandle index: anIndex. 
	^DBXColumnDescription 
		name: columnName
		dbxType: dbxType
		type: (self class dataTypeAt: dbxType).! !

!DBXPlatform methodsFor: 'private' stamp: 'EL 8/6/2008 08:58'!
descriptionForResult: aHandle on: aConnection
	| rowsAffected |

	rowsAffected := OpenDBX current apiQueryRowsAffected: aHandle.
	self  verifyError: rowsAffected on: aConnection. 
	^DBXResultDescription new
		rowsAffected: rowsAffected;
		yourself.
! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 8/14/2008 01:00'!
descriptionForResultSet: aHandle on: aConnection 
	| description columnCount |
	columnCount := OpenDBX current apiQueryColumns: aHandle.
	self verifyError: columnCount on: aConnection.
	description := DBXResultSetDescription new.
	(0 to: columnCount - 1)
		do: [:i | description
				addColumnDescription: (self
						descriptionForColumn: i
						handle: aHandle
						on: aConnection)].
	^ description! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 8/13/2008 02:13'!
endDBXResult: aConnection pageSize: aPageSize 
	| err handleArray timeout |
	handleArray := WordArray with: 0.
	timeout := DBXTimeSpec seconds: 3.
	[err := OpenDBX current
				apiQueryResult: aConnection handle
				handle: handleArray
				timeout: timeout
				chunk: aPageSize]
		doWhileFalse: [err = OpenDBX resultDone]! !

!DBXPlatform methodsFor: 'private' stamp: 'EL 8/6/2008 08:58'!
errorCode: err handle: aHandle
	DBXError signal: (OpenDBX current apiError: aHandle number: err)
	
! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 7/2/2008 01:26'!
errorCode: err on: aConnection
	self errorCode: err handle: aConnection handle. 

	
! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 8/16/2008 22:56'!
executeStatement: aQuery on: aConnection 
	"It executes the query using the connection and retrieve al rows at once (no pagination is used). 
	
There are some important things:

    * this method returns a DBXResultSet if it was a select statement and a DBXResult in case the query was an update, delete, insert, create, drop or any other DML query.
    * The queries sent to the server must be understood by the DBMS because there is no translation done between the different dialects of SQL for example. But this is desired!! It adds no further level of complexity to the library and your program which slows down your real work. Usually only a few statements with varying values are used in programs and the easiest way make them adaptable to different databases by the users is to get them from a configuration file, strategy pattern or whatever. "

	^self executeStatement: aQuery on: aConnection pageSize: 0.
! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 8/16/2008 22:57'!
executeStatement: aString on: aConnection pageSize: pageSize 
	"After executing a query, we will then want to retrieve the results. It may be possible to retrieve all rows at once, one by one or more than one row at once. All positive values including zero are allowed as values for a page size. As this is a special option that not all the engines support you must enable this feature using DBXConnection #enablePagedResults. If paging (more than one row at once) is not supported by the backend, it will use 'one by one' or 'all at once' if this is the only option provided."

	| err description |
	err := OpenDBX current
				apiQuery: aConnection handle
				query: aString
				length: aString size.
	self verifyError: err on: aConnection.
	self
		nextResultSet: aConnection
		pageSize: pageSize
		onReturn: [:handle :code | 
			code = OpenDBX resultWithoutRows
				ifTrue: [description := self descriptionForResult: handle on: aConnection.
					self endDBXResult: aConnection pageSize: pageSize.
					^ DBXResult
						on: aConnection
						handle: handle
						description: description].
			code = OpenDBX resultWithRows
				ifTrue: [description := self descriptionForResultSet: handle on: aConnection.
					^ DBXResultSet
						on: aConnection
						handle: handle
						description: description
						pageSize: pageSize]]! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'HMC 8/18/2008 12:21'!
fieldRawValue: anIndex on: aResultSet
	^OpenDBX current apiQueryFieldValue: (aResultSet handle) index: (anIndex - 1)! !

!DBXPlatform methodsFor: 'options' stamp: 'MMP 8/16/2008 23:01'!
getOption: anOption on: aConnection
	"It asks the backend if an specific option is supported or not" 
	| err isSupported |
	isSupported := WordArray with: 0.
	err := OpenDBX current
				apiGetOption: aConnection handle
				option: anOption
				value: isSupported.
	self verifyError: err on: aConnection.
	^ self smallIntegerAsBoolean: (isSupported at: 1)! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'EL 8/6/2008 08:57'!
largeFieldRawValue: anIndex on: aResultSet
	OpenDBX current apiQueryFieldValue: (aResultSet handle) index: (anIndex - 1)! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 8/18/2008 01:27'!
moveNext: aResultSet 
	| err |
	err := OpenDBX current apiQueryFetchRow: aResultSet handle.
	self verifyError: err on: aResultSet connection.
	err = OpenDBX rowDone
		ifTrue: [(self restartResultSet: aResultSet)
				ifTrue: [^ self moveNext: aResultSet]
				ifFalse: [^ nil]]
		ifFalse: [^ DBXRow on: aResultSet]! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 8/12/2008 23:29'!
nextResultSet: aResultSet ifDone: aBlock 
	^ self
		nextResultSet: aResultSet connection
		pageSize: aResultSet pageSize
		onReturn: [:handle :code | code = OpenDBX resultDone
				ifTrue: [aBlock value]]! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 8/14/2008 00:35'!
nextResultSet: aConnection pageSize: aPageSize onReturn: aBlock 
	| handle err handleArray timeout |
	handleArray := WordArray with: 0.
	timeout := DBXTimeSpec seconds: 3.
	err := OpenDBX current
				apiQueryResult: aConnection handle
				handle: handleArray
				timeout: timeout
				chunk: aPageSize.
	[self verifyError: err on: aConnection]
		on: DBXError
		do: [:e | 
			self endDBXResult: aConnection pageSize: aPageSize.
			e signal].
	handle := handleArray at: 1.
	aBlock notNil
		ifTrue: [aBlock value: handle value: err].
	^ handle! !

!DBXPlatform methodsFor: 'connection' stamp: 'HMC 8/18/2008 12:11'!
openConnection: aConnection 
	"'createConnection: should be called first'"
	"It opens the connection, by associating the handle created by
	'createConnection:' to a specific database after the server verified and
	accepted the user credentials. All further operations will (normally)
	only affect the tables and records within this database. The operations
	may be limited to certain subset depending on the privileges granted to
	the given user account. If 'openConnection:' succeeds, it also enables
	compatibility to the ANSI SQL standard if this is possible for the database
	server implementation."
	| err |
	err := OpenDBX current
				apiBind: aConnection handle
				database: aConnection settings database
				name: aConnection settings userName
				password: aConnection settings userPassword
				method: aConnection settings method.
	self verifyError: err on: aConnection.
	^ true! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 8/11/2008 23:14'!
queryDelimiter
	^self subclassResponsibility! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'HMC 8/18/2008 12:32'!
releaseAllQueryResultSets: aResultSet 
	"Releases all query resultsSets a query may return by iterating them.
	Each resultSet is Closed and all allocated memory by the OpenDBX
	library is freed ."
	| err resultCode |
	err := OpenDBX current apiQueryFinalize: aResultSet handle.
	self verifyError: err on: aResultSet connection.
	[self
		nextResultSet: aResultSet connection
		pageSize: aResultSet pageSize
		onReturn: [:handle :code | 
			code = OpenDBX resultWithRows
				ifTrue: [err := OpenDBX current apiQueryFinalize: handle].
			self verifyError: err on: aResultSet connection.
			resultCode := code]]
		doWhileFalse: [resultCode = OpenDBX rowDone]! !

!DBXPlatform methodsFor: 'connection' stamp: 'HMC 8/18/2008 12:12'!
releaseConnection: aConnection
	"It releases all the resources associated with a connection"
	| err |
	err := OpenDBX current apiFinalize: aConnection handle.
	self  verifyError: err on: aConnection.
! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'HMC 8/18/2008 12:32'!
releaseResultSet: aResultSet 
	"Closes a resultSet and all allocated memory by the OpenDBX library is
	freed . In case you want to realese all query resultSets, yo must call
	realeseAllQueryResultSets: "
	| err |
	err := OpenDBX current apiQueryFinalize: aResultSet handle.
	self verifyError: err on: aResultSet connection! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 8/18/2008 01:27'!
restartResultSet: aResultSet 
	| newResultSetHandle |
	self releaseResultSet: aResultSet.
	newResultSetHandle := self
				nextResultSet: aResultSet
				ifDone: [^ false].
	aResultSet handle: newResultSetHandle.
	"When I restart a resultSet is possible it changes the description, like the
	column count. For example, in multiple statements."
	aResultSet
		description: (self descriptionForResultSet: aResultSet handle on: aResultSet connection).
	^ true
! !

!DBXPlatform methodsFor: 'constants' stamp: 'HMC 8/12/2008 13:38'!
rollback
^'ROLLBACK'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'HMC 8/18/2008 12:33'!
rollback: aConnection
"executes a rollback statement on a connection"
^self executeStatement: self rollback on: aConnection.! !

!DBXPlatform methodsFor: 'options' stamp: 'MMP 8/18/2008 17:39'!
setOption: anOption value: anObject on: aConnection 
	"It enables an specific option for a connection."
	| err value |
	(anObject class = True) ifTrue: [value := ByteArray with: anObject asBit ].
	(anObject class = False) ifTrue: [value := ByteArray with: anObject asBit ].
	(anObject class = ByteString) ifTrue: [value := anObject ].
	err := OpenDBX current
				apiSetOption: aConnection handle
				option: anOption
				value: value.
	self verifyError: err on: aConnection! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 7/12/2008 01:39'!
smallIntegerAsBoolean: aSmallInteger
	(aSmallInteger = 1) ifTrue: [^true].
	(aSmallInteger = 0) ifTrue: [^false].
	DBXError signal: 'Cannot convert form SmallInteger to Boolean'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'HMC 8/18/2008 12:34'!
startTransaction
"It returns the start transaction statement most commonly used by the backends"
^'START TRANSACTION'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'HMC 8/18/2008 12:34'!
startTransaction: aConnection
"Starts a transaction on a connection"
^self executeStatement: self startTransaction on: aConnection.! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 8/16/2008 23:07'!
verifyError: err handle: aHandle
	"If verifies if a returned number of a call to an openDBX function, is an error or not. If true, a DBXError is thrown with the associated openDBX message for that error."
	(err < 0) ifTrue: [ self errorCode: err handle: aHandle]! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 8/16/2008 23:08'!
verifyError: err on: aConnection
	"If verifies if a returned number of a call to an openDBX function, is an error or not. If true, a DBXError is thrown with the associated openDBX message for that error."
	self verifyError: err handle: aConnection handle! !

DBXPlatform subclass: #DBXPostgresPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXPostgresPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the PostgreSQL specific platform definition. 

Instance Variables
!

!DBXPostgresPlatform methodsFor: 'as yet unclassified' stamp: 'EL 6/27/2008 20:30'!
backend
	^'pgsql'! !

!DBXPostgresPlatform methodsFor: 'accessing' stamp: 'MMP 6/13/2008 01:23'!
log: message
	self class log: message! !

!DBXPostgresPlatform methodsFor: 'accessing' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

Object subclass: #DBXResult
	instanceVariableNames: 'connection handle description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXResult class methodsFor: 'instance creation' stamp: 'MMP 8/16/2008 20:11'!
new
	self error: 'Use #on:handle:description:'! !

!DBXResult class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 12:59'!
on: aConnection handle: aNumber description: aDescription
	^(self basicNew)
		initializeConnection: aConnection 
			handle: aNumber
			description: aDescription;
		yourself.! !

!DBXResult methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:46'!
connection
	^ connection! !

!DBXResult methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:46'!
description
	^description! !

!DBXResult methodsFor: 'accessing' stamp: 'MMP 8/18/2008 01:12'!
description: aDescription 
	description := aDescription
! !

!DBXResult methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:46'!
handle
	^handle! !

!DBXResult methodsFor: 'accessing' stamp: 'MMP 8/18/2008 01:12'!
handle: aHandle 
	handle := aHandle
! !

!DBXResult methodsFor: 'testing' stamp: 'MMP 8/16/2008 20:22'!
hasRows
	"This answer if this type of result returns row or now. Not if it really has returned rows. For example, for deletes, inserts and updates, this will return false. It it is a select query, it will return true, no mater if the query didn't have results "
	^false! !

!DBXResult methodsFor: 'initialization' stamp: 'EL 6/29/2008 12:54'!
initializeConnection: aConnection handle: aNumber description: aDescription
	super initialize.
	connection := aConnection.
	handle := aNumber.
	description := aDescription.! !

!DBXResult methodsFor: 'testing' stamp: 'EL 6/29/2008 12:49'!
isOpen
	^false! !

!DBXResult methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:49'!
platform
	^self connection platform! !

!DBXResult methodsFor: 'testing' stamp: 'MMP 8/7/2008 00:33'!
releaseAllQueryResults
	"Maybe in a future this method could do something"! !

!DBXResult methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:35'!
rowsAffected
	"Returns the number of rows that have been changed by the current statement. Affected rows are only returned for DELETE, INSERT or UPDATE statements and their concrete number depends on the database implementation. 
	
	This value depends on the type of query:

    * DDL query: It will always be zero.
    * Insert query: It will always be one.
    * Delete and update: Returns the number of rows that have been changed by the current statement. However, their concrete number depends on the database implementation. Instead returning the number of rows which are matched by the WHERE clause, MySQL for example does only count the rows whose values have really been changed. "
	
	^self description rowsAffected! !

DBXResult subclass: #DBXResultSet
	instanceVariableNames: 'open pageSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXResultSet class methodsFor: 'as yet unclassified' stamp: 'MMP 8/12/2008 23:25'!
on: aConnection handle: aNumber description: aDescription pageSize: aPageSize
	^(self basicNew)
		initializeConnection: aConnection 
			handle: aNumber
			description: aDescription
			pageSize: aPageSize;
		yourself.! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:25'!
columnCount
	"Returns the number of columns affected in the query. It will be the columns you specify in the select statement"
	^self description columnCount! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:29'!
columnDescriptionAt: anIndex
	"Returns the column description at that index.
	IMPORTANT: The index starts in 1."
	^self description columnDescriptionAt: anIndex! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:40'!
columnDescriptionWithName: aName 
	"Returns the column description with that name. If a column with that name was not in select statement a DBXError will be thrown"
	^ [self columnDescriptions
		detect: [:each | each name sameAs: aName]]
		on: Error
		do: [DBXError signal: 'A column with that name was not in select statement']! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:31'!
columnDescriptions
	"Returns the column description of ALL the affected columns"
	^self description columnDescriptions! !

!DBXResultSet methodsFor: 'finalization' stamp: 'MMP 8/16/2008 20:47'!
finalize
	"Will finalize the DBXResultSet object"
	self isOpen ifTrue: [ self finalizeResultSet ]! !

!DBXResultSet methodsFor: 'finalization' stamp: 'MMP 8/16/2008 20:46'!
finalizeResultSet
	"It will release resources and change internal state"
	self platform releaseResultSet: self.
	self internalBeClosed.! !

!DBXResultSet methodsFor: 'private' stamp: 'MMP 8/13/2008 00:17'!
handle
	^handle! !

!DBXResultSet methodsFor: 'testing' stamp: 'MMP 8/16/2008 20:22'!
hasRows
"This answer if this type of result returns row or now. Not if it really has returned rows. For example, for deletes, inserts and updates, this will return false. It it is a select query, it will return true, no mater if the query didn't have results "
	^self isOpen ! !

!DBXResultSet methodsFor: 'initialization' stamp: 'MMP 8/16/2008 20:47'!
initializeConnection: aConnection handle: aNumber description: aDescription pageSize: aPageSize 
	super
		initializeConnection: aConnection
		handle: aNumber
		description: aDescription.
	pageSize := aPageSize.
	open := ValueHolder new contents: false.
	self internalBeOpen.! !

!DBXResultSet methodsFor: 'private' stamp: 'EL 6/27/2008 09:01'!
internalBeClosed
	open contents: false! !

!DBXResultSet methodsFor: 'private' stamp: 'EL 6/27/2008 09:01'!
internalBeOpen
	open contents: true! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:31'!
isOpen
	"Returns if the DBXResultSet is open or not."
	^open contents! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/18/2008 01:27'!
nextRow
	"it returns the next row of the resultSet. If there is no more row, it returns nil. 
	
	VERY IMPORTANT THINGS:

    * After doing a select query you should call nextRow till it returns you nil. If you don't do this, you will get a segmentation fault in your next query. You have to do this no matter which number of rows you have got. Suppose you are looking for some record and you find it in the second one. The number of rows is 10. In this case, you should call nextRow 10 times, no matter you found the record in the second one. This limitation is in the database client library. We assume that someone has to do this (retrieve all results before execute another query): openDBX, database client library, SqueakDBX or SqueakDBX user. So, we decided SqueakDBX should do this. The other approach was the SqueakDBX user should do it and if it doesn't do it, SqueakDBX throws an error. In conclusion, you DON'T need to call nextRow till nil its returned, the framework will do it for you in your next query.
    * Some queries return more than one resultSet. This situation will be transparent for SqueakDBX user. nextRow will automatically obtain next resultSet when needed. 

"
	| row |
	self isOpen
		ifFalse: [ DBXError signal: 'The resultSet must be open to obtain the next row but it is closed' ].
	row := self platform moveNext: self.
	row
		ifNil: [self internalBeClosed].
	^ row! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/12/2008 22:25'!
pageSize
	^ pageSize! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/12/2008 22:25'!
pageSize: anObject
	pageSize := anObject! !

!DBXResultSet methodsFor: 'finalization' stamp: 'MMP 8/16/2008 20:46'!
releaseAllQueryResults
	"It will release all the resources of all the resultsSets associated with a query."
	self isOpen
		ifTrue: [self platform releaseAllQueryResultSets: self.
			self internalBeClosed]! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'MMP 8/16/2008 20:43'!
rows
	"It returns in an OrderedCollection, ALL the rows of all the resultSets of a query"
	| results |
	results := OrderedCollection new.
	self rowsDo: [ :each| 
		results add: each ].
	^results! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'MMP 8/16/2008 20:44'!
rowsDo: aBlock
	"It will execute the block to each row"
	| row |
	[ row := self nextRow.
	  row notNil ] 
	whileTrue: [ aBlock value: row ]! !

Object subclass: #DBXResultDescription
	instanceVariableNames: 'rowsAffected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXResultDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:02'!
rowsAffected
"number of rows that have been changed by the current statement"
	^rowsAffected! !

!DBXResultDescription methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:52'!
rowsAffected: aNumber
	rowsAffected := aNumber ! !

Object subclass: #DBXResultSetDescription
	instanceVariableNames: 'columnDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:09'!
addColumnDescription: aColumnDescription
"it adds a new column description to the column descriptions collection"
	self columnDescriptions add: aColumnDescription! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:10'!
columnCount
"this allows you to know the number of columns for each row retrieved from the database"
	^self columnDescriptions size! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:11'!
columnDescriptionAt: anIndex
"returns the column description holded in 'anIndex' position"
	^self columnDescriptions at: anIndex! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:12'!
columnDescriptions
"Collection of column descriptions"
	^columnDescriptions ! !

!DBXResultSetDescription methodsFor: 'initialization' stamp: 'HMC 8/16/2008 21:09'!
initialize
"this DBXResultSetDescription will contain a collection of its own column descriptions, retrieved from the database"
	super initialize.
	columnDescriptions := OrderedCollection new.! !

Object subclass: #DBXRow
	instanceVariableNames: 'resultSet fields rawValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXRow class methodsFor: 'instance creation' stamp: 'EL 3/31/2008 10:21'!
new
	self error: 'Use #onResultSet:'! !

!DBXRow class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 11:27'!
on: aResultSet
	^(self basicNew)
		initializeResultSet: aResultSet;
		yourself.
		! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/27/2008 22:01'!
columnDescriptionAt: anIndex
	^self resultSet columnDescriptionAt: anIndex! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/27/2008 21:59'!
columnDescriptionType: anIndex
	^(self columnDescriptionAt: anIndex) type! !

!DBXRow methodsFor: 'private' stamp: 'HMC 8/12/2008 16:25'!
columnIndex: aString 
	self resultSet columnDescriptions
		withIndexDo: [:each :index | (each name sameAs: aString)
				ifTrue: [^ index]].
	DBXError signal: aString,'was not found'.! !

!DBXRow methodsFor: 'private' stamp: 'MMP 8/8/2008 00:10'!
convertValueAt: anIndex 
	^ (self rawValueAt: anIndex)
		ifNotNilDo: [:columnValue | (self columnDescriptionType: anIndex)
				fromDbxString: columnValue]! !

!DBXRow methodsFor: 'initialization' stamp: 'MMP 8/16/2008 21:15'!
initializeResultSet: aResultSet
	"It initialize a Row receiving a result set. We need the result set in order to ask the information about the column descriptions"
	super initialize.
	resultSet := aResultSet.
	self initializeRow.
	! !

!DBXRow methodsFor: 'initialization' stamp: 'MMP 8/16/2008 21:16'!
initializeRow
	"Initialize the row. All the row values will be set."
	rawValues := Array new: self resultSet columnCount.
	self resultSet columnDescriptions withIndexDo: [ :each :i|
		each isLarge
			ifTrue: [ DBXError signal: 'Large objects not supported yet' ]
			ifFalse: [ rawValues at: i put: (self platform fieldRawValue: i  on: self resultSet) ] ]! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/29/2008 12:19'!
platform
	^self resultSet platform! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:06'!
rawValueAt: anIndex
	"It returns the value of the raw at the specified index. No conversion is here, so all values will be String"
	^rawValues at: anIndex! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:07'!
rawValueNamed: aString
	"It returns the value of the raw with the specified name. No conversion is here, so all values will be String"
	^self rawValueAt: (self columnIndex: aString) ! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:07'!
rawValues
	"It returns the values of all the raw. No conversion is here, so all values will be String"
	^rawValues! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:09'!
rawValuesDo: aBlock
	"It will execute the block on all the row values. No conversion is here, so all values will be String"
	^self rawValues do: aBlock! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 3/31/2008 10:22'!
resultSet
	^ resultSet! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:11'!
valueAt: anIndex
	"It returns the value of the raw at the specified index. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self convertValueAt: anIndex 
! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:11'!
valueNamed: aString
	"It returns the value of the raw with the specified name. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self convertValueAt: (self columnIndex: aString).
! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:12'!
values
	"It returns the all the values of the raw. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self rawValues withIndexCollect: [ :each :index | 
		each ifNotNil: [
			(self columnDescriptionType: index) fromDbxString: each ] ]! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:12'!
valuesDo: aBlock
	"It will execute the block on all the row values. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self values do: aBlock! !

Object subclass: #DBXSpecialOptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
compression
	"0x0022 in hexadecimal in openDBX. But we need it as decimal"
	^16r0022! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
encryption
	 "0x0010 in hexadecimal in openDBX. But we need it as decimal"
	^16r0010! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
multipleStatements
	 "0x0020 in hexadecimal in openDBX. But we need it as decimal"
	^16r0020! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
pagedResults
 	"0x0021 in hexadecimal in openDBX. But we need it as decimal"
	^16r0021! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 8/18/2008 16:19'!
specialModes
	"0x0023 in hexadecimal in openDBX. But we need it as decimal"
	^16r0023
! !

Object subclass: #DBXTranscript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 7/18/2008 22:24'!
show: result
	result class = DBXResult
		ifTrue: [self showResult: result].
	result class = DBXResultSet
		ifTrue: [self showResultSet: result]! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 7/18/2008 22:25'!
showResult: result 
	Transcript show: 'They were affected ' , result rowsAffected asString, ' rows';
		 cr! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 8/14/2008 01:01'!
showResultSet: resultSet 
	| stream |
	stream := String new writeStream.
	resultSet columnDescriptions
		do: [:each | stream nextPutAll: each name]
		separatedBy: [stream nextPutAll: ' | '].
	Transcript show: stream contents;
		 cr.
	resultSet
		rowsDo: [:row | 
			stream := String new writeStream.
			row values
				do: [:each | stream nextPutAll: each asString]
				separatedBy: [stream nextPutAll: ' | '].
			Transcript show: stream contents;
				 cr]! !

Object subclass: #DBXTypeNotSupported
	instanceVariableNames: 'code type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTypeNotSupported commentStamp: 'EL 8/3/2008 08:33' prior: 0!
I'm an unsupported data type

Instance Variables
!

!DBXTypeNotSupported class methodsFor: 'instance creation' stamp: 'EL 8/14/2008 09:33'!
code: aNumber
	^self new
		code: aNumber;
		yourself! !

!DBXTypeNotSupported class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/5/2008 08:45'!
fromDbxString: aString
	self error: 'Type not supported'! !

!DBXTypeNotSupported class methodsFor: 'instance creation' stamp: 'EL 8/14/2008 09:33'!
type: aSymbol
	^self new
		type: aSymbol;
		yourself! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
code
	^ code! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
code: anObject
	code := anObject! !

!DBXTypeNotSupported methodsFor: 'as yet unclassified' stamp: 'EL 8/14/2008 11:56'!
fromDbxString: aString
	self type 
		ifNotNil: [ DBXError signal: 'Unsupported data type: ', self type, ', trying to parse: ', aString ]
		ifNil: [ DBXError signal: 'Unknown data type: ', self code, ', trying to parse: ', aString  ]! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
type
	^ type! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
type: anObject
	type := anObject! !

!Object class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:09'!
fromDbxString: aString
	self subclassResponsibility! !

!Object methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:18'!
asDbxString
	^ self printString! !

Object subclass: #OpenDBX
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!OpenDBX class methodsFor: 'instance creation' stamp: 'EL 8/6/2008 08:54'!
current
	^Current ifNil: [ Current := self new ]! !

!OpenDBX class methodsFor: 'constants' stamp: 'MMP 8/10/2008 17:26'!
currentOpenDBXVersion
	^'1.3.10'! !

!OpenDBX class methodsFor: 'instance creation' stamp: 'EL 8/6/2008 09:43'!
new
	SmalltalkImage current platformName = 'Win32' ifTrue:[ ^OpenDBXWin32 basicNew initialize].
	SmalltalkImage current platformName = 'unix' ifTrue:[ ^OpenDBXUnix basicNew initialize].
	SmalltalkImage current platformName = 'Mac OS' ifTrue:[ ^OpenDBXMacOSX basicNew initialize].
	self error: 'Cannot identify platform'.
! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 11:19'!
resultDone
	"ODBX_RES_DONE"
	^0! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:20'!
resultTimeout
	^1! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:21'!
resultWithRows
	^3! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:20'!
resultWithoutRows
	^2! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/28/2008 09:11'!
rowDone
	"ODBX_ROW_DONE"
	^0! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/28/2008 09:10'!
rowNext
	"ODBX_ROW_NEXT"
	^1! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiBind: handle database: databaseName name: userName password: password method: method
	"int odbx_bind(odbx_t* handle, const char* database, const char* who, const char* cred,int method )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiError: handle number: err
	"long odbx_error(odbx_t*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiFinalize: handle 
	"long odbx_finish(odbx_t*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiGetOption: handle option: anOption value: aValue
	"int odbx_get_option(odbx_t* handle, unsigned int option,void* value)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiInitialize: handle backend: backend host: host port: port
	"long odbx_init(odbx_t**, char*, char*, char*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiOpenLarge: aResultSetHandleNumber handle: aLargeHandleWordArray value: aString
	"int odbx_lo_open(odbx_result_t* result, odbx_lo_t** lo, const char* value)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQuery: handle query: query length: length
	"long odbx_query(odbx_t*, char*, ulong)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnLength: handle index: index
	"unsigned long odbx_field_length( odbx_result_t* result, unsigned long pos ) "
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnName: handle index: index
	"char* odbx_column_name(odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnType: handle index: index
	"char* odbx_column_type( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumns: handle
	"int odbx_column_count(odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFetchRow: handle 
	"int odbx_row_fetch( odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFieldValue: handle index: index
	"const char* odbx_field_value( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFinalize: handle
	"int odbx_result_finish( odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiQueryResult: connectionHandle handle: handle timeout: timeout chunk: chunk
	"int odbx_result( odbx_t* handle, odbx_result_t** result, struct timeval* timeout, unsigned long chunk )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiQueryRowsAffected: handle
	"uint64_t odbx_rows_affected(odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiSetOption: handle option: anOption value: aValue
	"int odbx_set_option(odbx_t* handle, unsigned int option, void* value ) "
	^self subclassResponsibility	
! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiUnbind: handle 
	"int odbx_unbind(odbx_t*)"
	^self subclassResponsibility! !

OpenDBX subclass: #OpenDBXUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

OpenDBXUnix subclass: #OpenDBXMacOSX
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:44'!
apiBind: handle database: databaseName name: userName password: password method: method
	"int odbx_bind(odbx_t* handle, const char* database, const char* who, const char* cred,int method )"
	<cdecl: long 'odbx_bind' (ulong char* char* char* ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:44'!
apiError: handle number: err
	"long odbx_error(odbx_t*)"
	<cdecl: char* 'odbx_error' (ulong long) module: 'opendbx' >
	^self externalCallFailed	! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:44'!
apiFinalize: handle 
	"long odbx_finish(odbx_t*)"
	<cdecl: long 'odbx_finish' (ulong) module: 'opendbx' >
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:44'!
apiGetOption: handle option: anOption value: aValue
	"int odbx_get_option(odbx_t* handle, unsigned int option,void* value)"
	<cdecl: long 'odbx_get_option' (ulong ulong void*) module: 'opendbx' >
	^self externalCallFailed
	
! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:45'!
apiInitialize: handle backend: backend host: host port: port
	"long odbx_init(odbx_t**, char*, char*, char*)"
	<cdecl: long 'odbx_init' (ulong* char* char* char*) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:45'!
apiOpenLarge: aResultSetHandleNumber handle: aLargeHandleWordArray value: aString
	"int odbx_lo_open(odbx_result_t* result, odbx_lo_t** lo, const char* value)"
	<cdecl: long 'odbx_lo_open' (ulong ulong* char*) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:45'!
apiQuery: handle query: query length: length
	"long odbx_query(odbx_t*, char*, ulong)"
	<cdecl: long 'odbx_query' (ulong char* ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:45'!
apiQueryColumnLength: handle index: index
	"unsigned long odbx_field_length( odbx_result_t* result, unsigned long pos ) "
	"IMPORTANT: Index es zero-based"
	<cdecl: long 'odbx_field_length' (ulong ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:45'!
apiQueryColumnName: handle index: index
	"char* odbx_column_name(odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: char* 'odbx_column_name' (ulong short) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:45'!
apiQueryColumnType: handle index: index
	"char* odbx_column_type( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: short 'odbx_column_type' (ulong short) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:46'!
apiQueryColumns: handle
	"int odbx_column_count(odbx_result_t* result )"
	<cdecl: long 'odbx_column_count' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:46'!
apiQueryFetchRow: handle 
	"int odbx_row_fetch( odbx_result_t* result )"
	<cdecl: long 'odbx_row_fetch' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'MMP 8/9/2008 22:33'!
apiQueryFieldValue: handle index: index
	"const char* odbx_field_value( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: char* 'odbx_field_value' (ulong ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:46'!
apiQueryFinalize: handle
	"int odbx_result_finish( odbx_result_t* result )"
	<cdecl: long 'odbx_result_finish' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'MMP 8/13/2008 00:42'!
apiQueryResult: connectionHandle handle: handle timeout: timeout chunk: chunk
	"int odbx_result( odbx_t* handle, odbx_result_t** result, struct timeval* timeout, unsigned long chunk )"
	<cdecl: long 'odbx_result' (ulong ulong* DBXTimeSpec ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:46'!
apiQueryRowsAffected: handle
	"uint64_t odbx_rows_affected(odbx_result_t* result )"
	<cdecl: long 'odbx_rows_affected' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 17:20'!
apiSetOption: handle option: anOption value: aValue
	"int odbx_set_option(odbx_t* handle, unsigned int option, void* value ) "
	<cdecl: long 'odbx_set_option' (ulong ulong char*) module: 'opendbx' >
	^self externalCallFailed
	
! !

!OpenDBXUnix methodsFor: 'as yet unclassified' stamp: 'EL 8/6/2008 09:47'!
apiUnbind: handle 
	"int odbx_unbind(odbx_t*)"
	<cdecl: long 'odbx_unbind' (ulong) module: 'opendbx' >
	^self externalCallFailed! !

OpenDBX subclass: #OpenDBXWin32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:39'!
apiBind: handle database: databaseName name: userName password: password method: method
	"int odbx_bind(odbx_t* handle, const char* database, const char* who, const char* cred,int method )"
	<apicall: long 'odbx_bind' (ulong char* char* char* ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:39'!
apiError: handle number: err
	"long odbx_error(odbx_t*)"
	<apicall: char* 'odbx_error' (ulong long) module: 'libopendbx-1.dll' >
	^self externalCallFailed	! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:39'!
apiFinalize: handle 
	"long odbx_finish(odbx_t*)"
	<apicall: long 'odbx_finish' (ulong) module: 'libopendbx-1.dll' >
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:40'!
apiGetOption: handle option: anOption value: aValue
	"int odbx_get_option(odbx_t* handle, unsigned int option,void* value)"
	<apicall: long 'odbx_get_option' (ulong ulong void*) module: 'libopendbx-1.dll' >
	^self externalCallFailed
	
! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:40'!
apiInitialize: handle backend: backend host: host port: port
	"long odbx_init(odbx_t**, char*, char*, char*)"
	<apicall: long 'odbx_init' (ulong* char* char* char*) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:41'!
apiOpenLarge: aResultSetHandleNumber handle: aLargeHandleWordArray value: aString
	"int odbx_lo_open(odbx_result_t* result, odbx_lo_t** lo, const char* value)"
	<apicall: long 'odbx_lo_open' (ulong ulong* char*) module: 'libopendbx-1.dll' >
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:41'!
apiQuery: handle query: query length: length
	"long odbx_query(odbx_t*, char*, ulong)"
	<apicall: long 'odbx_query' (ulong char* ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:41'!
apiQueryColumnLength: handle index: index
	"unsigned long odbx_field_length( odbx_result_t* result, unsigned long pos ) "
	"IMPORTANT: Index es zero-based"
	<apicall: long 'odbx_field_length' (ulong ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:42'!
apiQueryColumnName: handle index: index
	"char* odbx_column_name(odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<apicall: char* 'odbx_column_name' (ulong short) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:38'!
apiQueryColumnType: handle index: index
	"char* odbx_column_type( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<apicall: short 'odbx_column_type' (ulong short) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:42'!
apiQueryColumns: handle
	"int odbx_column_count(odbx_result_t* result )"
	<apicall: long 'odbx_column_count' (ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:42'!
apiQueryFetchRow: handle 
	"int odbx_row_fetch( odbx_result_t* result )"
	<apicall: long 'odbx_row_fetch' (ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:43'!
apiQueryFieldValue: handle index: index
	"const char* odbx_field_value( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<apicall: char* 'odbx_field_value' (ulong ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:43'!
apiQueryFinalize: handle
	"int odbx_result_finish( odbx_result_t* result )"
	<apicall: long 'odbx_result_finish' (ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:43'!
apiQueryResult: connectionHandle handle: handle timeout: timeout chunk: chunk
	"int odbx_result( odbx_t* handle, odbx_result_t** result, struct timeval* timeout, unsigned long chunk )"
	<apicall: long 'odbx_result' (ulong ulong* DBXTimeSpec long) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:43'!
apiQueryRowsAffected: handle
	"uint64_t odbx_rows_affected(odbx_result_t* result )"
	<apicall: long 'odbx_rows_affected' (ulong) module: 'libopendbx-1.dll'>
	^self externalCallFailed! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/18/2008 17:42'!
apiSetOption: handle option: anOption value: aValue
	"int odbx_set_option(odbx_t* handle, unsigned int option, void* value ) "
	<apicall: long 'odbx_set_option' (ulong ulong char*) module: 'libopendbx-1.dll' >
	^self externalCallFailed
	
! !

!OpenDBXWin32 methodsFor: 'api calls' stamp: 'MMP 8/9/2008 22:44'!
apiUnbind: handle 
	"int odbx_unbind(odbx_t*)"
	<apicall: long 'odbx_unbind' (ulong) module: 'libopendbx-1.dll' >
	^self externalCallFailed! !

!True methodsFor: '*OpenDBX-Core' stamp: 'EL 8/14/2008 09:18'!
asDbxString
	^'true'! !

!Number class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:10'!
fromDbxString: aString
	^self readFrom: aString readStream! !

!Date class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:36'!
fromDbxString: aString 
	^ self readDbxFrom: aString readStream! !

!Date class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:09'!
readDbxFrom: aStream
	| year month day |

	year := (aStream upTo: $-) asInteger.
	month := (aStream upTo: $-) asInteger.
	day := (aStream upToEnd) asInteger.

	^self year: year 
		month: month 
		day: day! !

!Date methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:27'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents asDbxString ! !

!Date methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:27'!
printDbxOn: aStream
	aStream
		nextPutAll: self year asString;
		nextPut: $-;
		nextPutAll: (self monthIndex asString padded: #left to: 2 with: $0);
		nextPut: $-;
		nextPutAll: (self dayOfMonth asString padded: #left to: 2 with: $0).! !

!UndefinedObject methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 12:49'!
asDbxString
	^'NULL'! !

!Boolean class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:55'!
fromDbxString: aString
	aString = '1' ifTrue: [ ^true ].
	aString = '0' ifTrue: [ ^false ].
	DBXError signal: 'Invalid boolean input: ', aString! !

Error subclass: #DBXError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!
DBXConnection initialize!
